'TO DO LIST
'** Flexible pop-up
	'* similar to alert scheme
	'* parameters: box coordinates not to cover
	'*             clean-up toggle
	'*             Info text
	'*             action text
	'*             returns choice
'** CHANGE ORDERS effects

DECLARE SUB GameQuit ()
DECLARE SUB GameSave ()
DECLARE SUB GameLoad ()
DECLARE SUB GameNew ()
DECLARE SUB setup ()
DECLARE SUB PlayerActionPhase ()
DECLARE SUB PlayerNext ()
DECLARE SUB arrow (X1%, Y1%, d%)
DECLARE SUB ShiftStatus (status%)
DECLARE SUB ProcessKeyBoard (k%, event$)
DECLARE SUB ProcessMouse (event$)
DECLARE SUB ProcesMenu (X%, event$)
DECLARE SUB MapPosition (mx%, my%, Col%, row%)
DECLARE SUB HelpTopic ()
DECLARE SUB HelpOrders ()
DECLARE SUB HelpTerrain ()
DECLARE SUB TerrainCost (X1%, Y1%, dir%, u%, cost%)
DECLARE SUB TerrainAssign (n%, n$, Foot%, Mech%, Mobile%, i%, a%, f%, d%)
DECLARE SUB OrderAssign (O%, M1%, a1%, D1%, M2%, a2%, D2%, M3%, A3%, D3%, m%)
DECLARE SUB ArmyOrders (s%)
DECLARE SUB Reinforcements ()
DECLARE SUB FIRE (FP%, prof%, TargetID%, damage%, dis%)
DECLARE SUB UnitResults (u%, damage%, disruption%)
DECLARE SUB UnitCombat (u%)
DECLARE SUB UnitRetreat (u%)
DECLARE SUB UnitArrow (u%)
DECLARE SUB UnitMoveZone (u%, X1%, Y1%)
DECLARE SUB UnitPopUp (u%)
DECLARE SUB UnitGet (X%, Y%, unit%)
DECLARE SUB UnitDraw (u%)
DECLARE SUB UnitAssign (u%, s%, a%, d$, UT%, f%, MP%, eff%, hex%)
DECLARE SUB MenuLoad ()
DECLARE SUB MenuGet (tmenu%)
DECLARE SUB MESSAGE (msg$, secs%)
DECLARE SUB Alert (Text$(), Buttons$(), X%, Y%, ReturnButton%)
DECLARE SUB MSGLENGTH ()
DECLARE SUB anykey ()
DECLARE SUB ColorList ()
DECLARE SUB GetPath (drive$, pp$)
DECLARE SUB Credits ()
DECLARE SUB MoveDir (d%, X%, Y%, NX%, NY%)
DECLARE SUB MapDraw ()
DECLARE SUB MapLoad (m$)

DECLARE FUNCTION UnitFirstFire% (u%)
DECLARE FUNCTION UnitOffFire% (u%)
DECLARE FUNCTION UnitDefFire% (u%)
DECLARE FUNCTION Player% (u%)
DECLARE FUNCTION VictoryCheck% ()
DECLARE FUNCTION EXIST% (file$)
DECLARE FUNCTION GETINKEY% ()
DECLARE FUNCTION CalcDir% (C1%, r1%, C2%, r2%)
DECLARE FUNCTION ADJACENT% (X1%, Y1%, x2%, y2%)
DECLARE FUNCTION INBOX% (X%, Y%, X1%, Y1%, x2%, y2%)
DECLARE FUNCTION MAX% (V1%, V2%)
DECLARE FUNCTION MIN% (V1%, V2%)
DECLARE FUNCTION BIN$ (n%)
DECLARE FUNCTION FORM$ (n!, d%)


'Created by Thomas A. Stevenson (thomas99@phenixcable.net) on 7/26/00 using
'Future.Library 3.03 created by Michael Rye Sorensen and Jordan Chamid
'

REM $INCLUDE: 'future.bi'
REM $DYNAMIC

DEFINT A-Z

	'********************* KeyBoard Constants ****************
	CONST left = 1075, RIGHT = 1077, PGDN = 1081, PGUP = 1073
	CONST UP = 1072, DOWN = 1080, ESC = 27, TABKEY = 9, CR = 13
	CONST HOME = 1071, ENDKEY = 1079, SHIFTTAB = 1015
	'****************  Color Constants ************************
	CONST BLACK = 0, WHITE = 4, RED = 3, DGREEN = 2, GREEN = 5, LTGREEN = 1
	CONST DBLUE = 6, BLUE = 7, LTBLUE = 8, LTGRAY = 9, GRAY = 10, DrGray = 11
	CONST YELLOW = 12, LtBrown = 13, Brown = 14
	'********************** Map Constants **************************
	'** Viewport size in pixels
	CONST px1 = 10, py1 = 100, px2 = 790, py2 = 570
	CONST bigstep = py2 - py1 - 10, smallstep = 50
	CONST SLIDERW = 8, nScreens = 4, xScreens = 2, yScreens = 2
	'************************ Logical Constants *******************
	CONST TRUE = -1, FALSE = 0
	CONST GERMAN = 0, RUSSIAN = 1
 
	COMMON SHARED workscreen, Buffer, Page
	COMMON SHARED mouseposY, mouseposX, LMousebutton, RMousebutton
	COMMON SHARED HexNumbers, CenterDots, HEXs, aHex, EZOC, MoveArea
	COMMON SHARED maxX, maxY, Ysize, Xsize, TotalX, TotalY
	COMMON SHARED cellsizeX, cellsizeY
	COMMON SHARED HX, HY, MSGSECS
	COMMON SHARED nUnits, TURN, Mode, Phase, cPLAYER, ActiveUnit
	COMMON SHARED map(), road(), river(), move(), zoc(), XMSscreens()
	COMMON SHARED tname() AS STRING * 10, Foot(), Mech(), Mobile(), inf(), arm(), first(), damMod()
	COMMON SHARED U1(), U2(), U3(), U4(), U5(), U6(), mask()
	COMMON SHARED r1(), r2(), r3(), r4(), r5(), r6(), r7(), r8()
	COMMON SHARED g1(), g2(), g3(), g4(), g5(), g6(), hex()
	COMMON SHARED a1(), a2(), a4(), a8(), a16(), a32()
	COMMON SHARED unittype(), army(), desgn$(), str(), ma(), UnitX(), UnitY()
	COMMON SHARED uOrder(), effectiveness(), skill(), mps()
	COMMON SHARED attack(), UT(), sHEX()
	COMMON SHARED army$(), aOrders(), ordertext() AS STRING * 10
	COMMON SHARED dir(), Mode$(), Phase$()
	COMMON SHARED orderEFF(), DamageEff()
	COMMON SHARED nSubm(), submenu()  AS STRING * 12

	DIM SHARED map(1, 1), road(1, 1), river(1, 1), move(1, 1), zoc(1, 1)
	DIM SHARED XMSscreens(1 TO nScreens, 0 TO 2)
	DIM SHARED tname(9) AS STRING * 10
	DIM SHARED Foot(9), Mech(9), Mobile(9), inf(9), arm(9), first(9), damMod(9)
	DIM SHARED nSubm(4), submenu(4, 6)  AS STRING * 12
	s = 900
	DIM SHARED U1(s), U2(s), U3(s), U4(s), U5(s), U6(s), mask(s)
	R = 20 * 8
	DIM SHARED r1(R), r2(R), r3(R), r4(R), r5(R), r6(R), r7(R), r8(R)
	DIM SHARED g1(R), g2(R), g3(R), g4(R), g5(R), g6(R)
	DIM SHARED hex(25 * 68)
	a = 300
	DIM SHARED a1(a), a2(a), a4(a), a8(a), a16(a), a32(a)
	u = 52
	DIM SHARED unittype(u), army(u), desgn$(u), str(u), ma(u), UnitX(u), UnitY(u)
	DIM SHARED uOrder(u), effectiveness(u), skill(u), mps(u)
	DIM SHARED attack(u), UT(u), sHEX(u)
	DIM SHARED army$(15), aOrders(15), ordertext(4)  AS STRING * 10
	DIM SHARED dir(6), Mode$(4), Phase$(3)
	DIM SHARED orderEFF(0 TO 4, 0 TO 3, 1 TO 3), DamageEff(0 TO 4)
 
	CALL setup
	CALL MapLoad("mapdata")

	'**** Put Initial Page on Screen
	Future.MouseOn
	CALL SetLocation(px1 + (px2 - px1) / 2, py1 + (py2 - py1) / 2)
	CALL MenuLoad
	Future.PRINT 300, 260, "Starting New Game", BLACK, WHITE
	CALL GameNew
	CALL MapDraw
	CALL Credits

	'** Main control loop
	DO
		Future.UpdateMouse
		ProcessMouse (event$)
		KeyCode = GETINKEY
		ProcessKeyBoard KeyCode, event$
	LOOP

REM $STATIC
SUB FIRE (FP, prof, TargetID, damage, dis)
 
	damage! = (FP ^ .85) * (prof / 10) / 4
	ter = map(UnitX(TargetID), UnitY(TargetID))
	Moddamage! = damage! * damMod(ter) * DamageEff(uOrder(TargetID)) / 10000
	extradamage! = Moddamage! - INT(Moddamage!)
	damage = INT(Moddamage!)
	RANDOMIZE TIMER
	roll! = RND
	IF roll! < extradamage! THEN damage = damage + 1
	dis = MAX((damage + 1) * 60 / prof, 5)
 
	DIM t$(12), B$(1)

	t$(1) = "            Combat Result Analysis "
	t$(2) = "Target: " + desgn$(TargetID)
	t$(3) = "Damage=(FP^.85)*(Skill/10)*(Modifiers) /4 "
	t$(4) = "FP = " + STR$(FP) + " Skill = " + STR$(prof)
	t$(5) = "Raw Damage = " + FORM$(damage!, 3)
	t$(6) = "Terrain Modification:" + FORM$(damMod(ter) / 100, 2)
	t$(6) = t$(6) + "   " + tname$(ter)
	t$(7) = "Orders Modification :" + FORM$(DamageEff(uOrder(TargetID)) / 100, 2)
	t$(7) = t$(7) + "   " + ordertext(uOrder(TargetID))
	t$(8) = "Modified Damage     :" + FORM$(Moddamage!, 3)
	t$(9) = "Random Number Result:" + FORM$(roll!, 3)
	t$(10) = "Final Damage        :" + STR$(damage)
	t$(11) = "Disruption          :" + STR$(dis)

	B$(1) = "  OK  "

	CALL Alert(t$(), B$(), 0, 0, C)

END SUB

SUB GameLoad

	DIM t$(3), B$(2)

	t$(1) = "      Load Save Game ?     "
	t$(2) = ""
	t$(3) = ""

	B$(1) = "  LOAD  "
	B$(2) = " CANCEL "

	CALL Alert(t$(), B$(), 0, 0, C)
	IF C = 2 THEN EXIT SUB

	file$ = "GameSave.bin"
	IF EXIST%(file$) THEN
		f = FREEFILE
		OPEN file$ FOR RANDOM AS f
		Bytes = LOF(f)
		CLOSE f
		TotalWords = (Bytes) / 2
		DIM H(TotalWords)

		DEF SEG = VARSEG(H(0))
		BLOAD file$, VARPTR(H(0))
		DEF SEG

		CALL GameNew

		TURN = H(0)
		Phase = H(1)
		Mode = H(2)
		cPLAYER = H(3)
		k = 4
		FOR a = 1 TO 15
			aOrders(a) = H(k)
			k = k + 1
		NEXT a
		FOR u = 1 TO 52
			str(u) = H(k)
			mps(u) = H(k + 1)
			UnitX(u) = H(k + 2)
			UnitY(u) = H(k + 3)
			effectiveness(u) = H(k + 4)
			uOrder(u) = H(k + 5)
			'** Dead unit
			IF UnitX(u) = -1 THEN unittype(u) = 0
			IF UnitY(u) = -1 THEN unittype(u) = 0
			IF str(u) < 1 THEN
				unittype(u) = 0
				UnitX(u) = -1
				UnitY(u) = -1
			END IF
			k = k + 6
		NEXT u
		MapDraw
	ELSE
		MESSAGE "File Not Found", MSGSECS
	END IF


END SUB

SUB GameNew
 
	nUnits = 52
	FOR i = 0 TO nUnits
		UnitAssign i, 0, 0, "", 0, 0, 0, 0, -101
	NEXT i

	army$(1) = "12th ARMY": aOrders(1) = 2
	UnitAssign 1, 5, 1, "52nd INF", 1, 4, 4, 6, 10
	UnitAssign 2, 5, 1, "53nd INF", 1, 4, 4, 6, 210
	UnitAssign 3, 5, 1, "54nd INF", 1, 4, 4, 6, 411
	army$(2) = "77th ARMY": aOrders(2) = 2
	UnitAssign 4, 5, 2, "202nd INF", 1, 4, 4, 6, 611
	UnitAssign 5, 5, 2, "207nd INF", 1, 4, 4, 6, 711
	UnitAssign 6, 5, 2, "83rd INF", 1, 4, 4, 6, 912
	army$(3) = "5th SHOCK ARMY": aOrders(3) = 1
	UnitAssign 7, 5, 3, "15th Shock", 2, 6, 5, 7, 1212
	UnitAssign 8, 5, 3, "17th Shock", 2, 5, 5, 7, 1310
	UnitAssign 9, 5, 3, "22nd Shock ", 2, 5, 4, 7, 1509
	UnitAssign 10, 5, 3, "27nd Shock ", 2, 5, 4, 7, 1708
	army$(4) = "54th ARMY": aOrders(4) = 2
	UnitAssign 11, 5, 4, "503nd INF", 1, 3, 4, 5, 1907
	UnitAssign 12, 5, 4, "377nd INF", 1, 3, 4, 5, 2106
	UnitAssign 13, 5, 4, "453nd INF", 1, 3, 4, 5, 2305
	army$(5) = "2nd TANK ARMY": aOrders(5) = 3
	UnitAssign 14, 4, 5, "12th Tank", 2, 8, 6, 7, 820
	UnitAssign 15, 4, 5, "4th Tank", 2, 9, 6, 7, 821
	UnitAssign 16, 6, 5, "7th Tank", 2, 7, 5, 7, 822
	army$(6) = "1st Guards": aOrders(6) = 2
	UnitAssign 17, 5, 6, "3rd Gds", 2, 6, 5, 8, 1326
	UnitAssign 18, 5, 6, "2nd Gds", 2, 7, 5, 8, 1525
	UnitAssign 19, 5, 6, "1st Gds", 2, 8, 5, 8, 1527
	UnitAssign 20, 5, 6, "4th Gds", 2, 6, 5, 8, 1725

	army$(10) = "12th Korps": aOrders(10) = 2
	UnitAssign 30, 3, 10, "44th Inf", 2, 6, 5, 7, 109
	UnitAssign 31, 3, 10, "52nd Inf", 2, 5, 5, 7, 309
	UnitAssign 32, 3, 10, "208th Inf", 2, 4, 5, 7, 510
	UnitAssign 33, 3, 10, "17th Volk", 2, 4, 4, 7, 710
	UnitAssign 34, 3, 10, "23rd Volk", 2, 4, 4, 6, 911
	army$(11) = "Gds Korps": aOrders(11) = 4
	UnitAssign 35, 3, 11, "Bauer", 2, 8, 5, 9, 1012
	UnitAssign 36, 3, 11, "Gds Inf", 2, 9, 5, 9, 1210
	UnitAssign 37, 3, 11, "Leib", 2, 7, 6, 9, 1409
	army$(12) = "44th Korps": aOrders(12) = 2
	UnitAssign 38, 3, 12, "52th Volk", 2, 4, 3, 7, 1608
	UnitAssign 39, 3, 12, "14th Volk", 2, 4, 3, 7, 1807
	UnitAssign 40, 3, 12, "355th Inf", 2, 5, 4, 7, 2006
	UnitAssign 41, 3, 12, "53rd Volk", 2, 4, 3, 7, 2205
	army$(13) = "2nd Panzer Korps": aOrders(13) = 3
	UnitAssign 42, 1, 13, "12th Pz", 3, 10, 6, 8, 707
	UnitAssign 43, 1, 13, "14th Pz", 3, 12, 6, 8, 708
	UnitAssign 44, 1, 13, "3rd PzGr", 3, 8, 7, 8, 807
	UnitAssign 45, 1, 13, "17th Pz", 3, 10, 6, 8, 808
	army$(14) = "5th Panzer Korps": aOrders(14) = 3
	UnitAssign 46, 1, 14, "5th Pz", 3, 10, 6, 6, 1503
	UnitAssign 47, 2, 14, "TotenKopf", 3, 14, 6, 8, 1504
	UnitAssign 48, 1, 14, "4th PzGr", 3, 8, 7, 6, 1604
	UnitAssign 49, 1, 14, "21st Pz", 3, 12, 6, 6, 1605
	army$(15) = "Reserve Panzer Korps": aOrders(15) = 3
	UnitAssign 50, 2, 15, "Ostwind", 3, 12, 6, 7, 701
	UnitAssign 51, 1, 15, "1st Pz", 3, 14, 7, 7, 702
	UnitAssign 52, 1, 15, "2nd Pz", 3, 12, 6, 7, 802


	FOR Y = 0 TO TotalY - 1
		FOR X = 0 TO TotalX - 1
			move(X, Y) = -1
			zoc(X, Y) = 0
		NEXT X
	NEXT Y

	ActiveUnit = 0
	cPLAYER = RUSSIAN
	TURN = 0
	Mode = 1
	Phase = 1
	CALL PlayerNext

END SUB

SUB GameQuit
	'*** Clean-up and exit
	Future.MouseOff
	DeallocateXMS workscreen 'free up XMS memory
	DeallocateXMS Buffer 'free up XMS memory
	FOR i = 1 TO nScreens
		DeallocateXMS XMSscreens(i, 0) 'free up XMS memory
	NEXT i
	ReSetScreen
	END

END SUB

SUB GameSave

	DIM t$(3), B$(2)

	t$(1) = "       Save Game ?     "

	B$(1) = "  SAVE  "
	B$(2) = " CANCEL "

	CALL Alert(t$(), B$(), 0, 0, C)
	IF C = 2 THEN EXIT SUB

	DIM H(350)
	H(0) = TURN
	H(1) = Phase
	H(2) = Mode
	H(3) = cPLAYER
	k = 4
	FOR a = 1 TO 15
		H(k) = aOrders(a)
		k = k + 1
	NEXT a
	FOR u = 1 TO 52
		H(k) = str(u)
		H(k + 1) = mps(u)
		H(k + 2) = UnitX(u)
		H(k + 3) = UnitY(u)
		H(k + 4) = effectiveness(u)
		H(k + 5) = uOrder(u)
		k = k + 6
	NEXT u

	DEF SEG = VARSEG(H(0))
	BSAVE "GameSave.bin", VARPTR(H(0)), k * 2 + 7
	DEF SEG

	MESSAGE "  Game Saved  ", MSGSECS

END SUB

SUB MapPosition (mouseposX, mouseposY, Col, row)
	row = -1: Col = -1
	IF INBOX(mouseposX, mouseposY, px1, py1, px2, py2) THEN
		row = INT((mouseposY + HY - py1) / cellsizeY)
		Col = INT((mouseposX + HX - px1 + cellsizeX / 2 - (row MOD 2) * cellsizeX / 2) / cellsizeX)
		IF INBOX(Col, row, 0, 0, TotalX - 1, TotalY - 1) THEN
		
			s$ = "0000"
			t$ = s$ + LTRIM$(STR$(row * 100 + Col))
			t$ = MID$(t$, LEN(t$) - 3, 4)

			Future.PRINT 0, 32, "HEX    :" + t$, RED, 0
			Future.PRINT 0, 48, "Terrain:" + tname(map(Col, row)), RED, 0
			tr$ = "INF X" + MID$(STR$(inf(map(Col, row))) + "  ", 1, 4)
			'     Future.Print 150, 48, tr$, RED, WHITE
			tr$ = "ARM X" + MID$(STR$(arm(map(Col, row))) + "  ", 1, 4)
			'     Future.Print 240, 48, tr$, RED, WHITE
			Future.PRINT 0, 64, "ROAD   :" + BIN$(road(Col, row)), RED, 0
			Future.PRINT 0, 80, "River  :" + BIN$(river(Col, row)) + " ", RED, 0
		END IF
	END IF

END SUB

SUB MenuGet (tmenu)
	FC& = BLACK
	FB& = BLUE
	FS& = WHITE

	SetViewPort 0, 0, 800, 600
	TempScreen = AllocateXMS(480000) 'get 256000 bytes of XMS memory
	Future.MouseOff
	Future.XMSget 0, 0, 800, 600, TempScreen
	Future.MouseOn

	cMenu = MIN(INT(Future.MouseY / 16), nSubm(Tx))
	GOSUB drawSubMenu
	DONE = FALSE
	DO: Future.UpdateMouse: LOOP UNTIL Future.MouseB = 0
	DO: CALL ShiftStatus(s): LOOP UNTIL NOT (s AND 8)
	SLEEP 1

	DO
		Future.UpdateMouse
		Tx = MIN(INT(Future.MouseX / 80) + 1, nSubm(0))
		Ty = MIN(INT(Future.MouseY / 16), nSubm(Tx))
		IF Tx <> tmenu OR Ty <> cMenu THEN
			tmenu = Tx
			cMenu = Ty
			GOSUB drawSubMenu
		END IF
		IF Future.MouseB AND 1 THEN DONE = TRUE

		k = GETINKEY
		IF k > 0 THEN GOSUB MenuKey
	 
		CALL ShiftStatus(s)
		IF s AND 8 THEN
			DONE = TRUE
			k = ESC
			SLEEP 1
			DO: CALL ShiftStatus(s): LOOP UNTIL NOT (s AND 8)
		END IF

	LOOP UNTIL DONE

	IF k = CR THEN
		tmenu = tmenu * 10 + cMenu
	ELSEIF k = ESC THEN
		tmenu = 0
	ELSEIF Future.MouseX > 80 * nSubm(0) THEN
		tmenu = 0
	ELSEIF Future.MouseY - 16 > 16 * nSubm(Tx) THEN
		tmenu = 0
	ELSE
		tmenu = Tx * 10 + Ty
	END IF

	Future.MouseOff
	Future.XMSput 0, 0, TempScreen
	DeallocateXMS TempScreen 'free up XMS memory
	Future.MouseOn
	DO: LOOP UNTIL INKEY$ = ""
	DO: Future.UpdateMouse: LOOP UNTIL Future.MouseB = 0
	

EXIT SUB

drawSubMenu:
	Future.MouseOff
	Page = Page XOR 1
	SetPage Page
	Future.XMSput 0, 0, TempScreen
	FOR m = 1 TO nSubm(0)
		IF m = tmenu THEN
			Future.PRINT 80 * (m - 1), 0, submenu(m, 0), WHITE, FB&
		ELSE
			Future.PRINT 80 * (m - 1), 0, submenu(m, 0), FC&, FB&
		END IF
	NEXT m
	FOR n = 1 TO nSubm(tmenu)
		IF n = cMenu THEN
			Future.PRINT 80 * (tmenu - 1), n * 16, submenu(tmenu, n), FC&, FS&
		ELSE
			Future.PRINT 80 * (tmenu - 1), n * 16, submenu(tmenu, n), FC&, FB&
		END IF
	NEXT n
	ViewPage Page
	Future.MouseOn

RETURN

MenuKey:

	SELECT CASE k
	CASE UP: cMenu = MAX(cMenu - 1, 1)
	CASE DOWN:  cMenu = MIN(cMenu + 1, nSubm(tmenu))
	CASE RIGHT: tmenu = MIN(tmenu + 1, nSubm(0))
	CASE left: tmenu = MAX(tmenu - 1, 1)
	CASE ESC: DONE = TRUE
	CASE CR: DONE = TRUE
	END SELECT
	GOSUB drawSubMenu
		 
	mx = 80 * (tmenu - 1) + 5
	my = cMenu * 16 + 5
	CALL SetLocation(mx, my)


RETURN
END SUB

SUB MenuLoad

	Future.PRINT 300, 240, "Loading menus", BLACK, WHITE
	nSubm(0) = 4                     '***  Number of Menu Titles
	submenu(0, 0) = SPACE$(12)       '***  Used for overwriting previous title

	submenu(1, 0) = "FILE"           '***  n,0 = Menu Title
	submenu(1, 1) = "New Game    "   '***  n,m = menu item
	submenu(1, 2) = "Load      F4"
	submenu(1, 3) = "Save      F5"
	submenu(1, 4) = "Colors    F6"
	submenu(1, 5) = "Quit     esc"
	nSubm(1) = 5                     '*** Number of menu items under menu title

	submenu(2, 0) = "PHASE"
	submenu(2, 1) = "NextPhase F2"
	submenu(2, 2) = "ArmyOrders A"
	submenu(2, 3) = "Victory?    "
	nSubm(2) = 3

	submenu(3, 0) = "View"
	submenu(3, 1) = "Dots are OFF": CenterDots = FALSE
	submenu(3, 2) = "HEXs are ON": HEXs = TRUE
	submenu(3, 3) = "Nums are OFF": HexNumbers = FALSE
	submenu(3, 4) = "EZOC is   ON": EZOC = TRUE
	submenu(3, 5) = "Move area ON": MoveArea = TRUE
	nSubm(3) = 5

	aHex = 6
	submenu(4, 0) = "Help/Info"
	submenu(4, 1) = "Terrain Eff "
	submenu(4, 2) = "Orders Eff  "
	submenu(4, 3) = "Help File F1"
	submenu(4, 4) = "Credits     "
	submenu(4, 5) = "Set Msg Time"
	submenu(4, 6) = "Victory Cond"
	nSubm(4) = 6
 

END SUB

SUB OrderAssign (n, M1, a1, D1, M2, a2, D2, M3, A3, D3, cmbt)
	'** Movement effect
	orderEFF(n, 1, 1) = M1
	orderEFF(n, 2, 1) = M2
	orderEFF(n, 3, 1) = M3
	'** Attack Effect
	orderEFF(n, 1, 2) = a1
	orderEFF(n, 2, 2) = a2
	orderEFF(n, 3, 2) = A3
	'** Defense Effect
	orderEFF(n, 1, 3) = D1
	orderEFF(n, 2, 3) = D2
	orderEFF(n, 3, 3) = D3
	DamageEff(n) = cmbt

END SUB

FUNCTION Player% (u)
 
	IF u = 0 THEN Player = -1: EXIT FUNCTION
	Player = RUSSIAN: IF army(u) > 9 THEN Player = GERMAN
	'** 0 = German
	'** 1 = Russian

END FUNCTION

SUB PlayerActionPhase
	 
	FOR u = 1 TO nUnits
		IF Player(u) = cPLAYER THEN
			IF orderEFF(uOrder(u), UT(u), 1) = -1 THEN
				mps(u) = -1
			ELSE
				mps(u) = ma(u) * orderEFF(uOrder(u), UT(u), 1) / 100
			END IF
		END IF
	NEXT u
	Mode = 1

END SUB

SUB PlayerNext

	FOR Y = 0 TO TotalY - 1
		FOR X = 0 TO TotalX - 1
			move(X, Y) = -1
			zoc(X, Y) = 0
		NEXT X
	NEXT Y

	ActiveUnit = 0
	IF TURN = 0 THEN GOTO skiprecovery
	'** Recovery from disruption based on orders
	FOR u = 1 TO nUnits
		sHEX(u) = 0
		IF Player(u) = cPLAYER THEN
			IF uOrder(u) = 2 THEN
				R = 30: effectiveness(u) = effectiveness(u) + 30
			ELSEIF uOrder(u) = 1 THEN
				R = 10: effectiveness(u) = effectiveness(u) + 10
			ELSEIF uOrder(u) = 4 AND mps(u) > 1 THEN
				R = 5: effectiveness(u) = effectiveness(u) + 5
			ELSE
				R = 5 * mps(u): effectiveness(u) = effectiveness(u) + 5 * mps(u)
			END IF
			effectiveness(u) = MIN(effectiveness(u), 100)
			mps = 0
		END IF
		attack(u) = 0
	NEXT u
 
	DIM a(30)
	FOR u = 1 TO nUnits
		IF Player(u) = cPLAYER THEN
			didalready = FALSE
			FOR i = 1 TO 30
				IF army(u) = a(i) THEN didalready = TRUE
			NEXT i
			IF NOT didalready THEN
				k = k + 1: a(k) = army(u)
				D1$ = army$(army(u)) + " {" + RTRIM$(ordertext(aOrders(army(u)))) + "}"
				IF uOrder(u) = 2 THEN
					R$ = "30"
				ELSEIF uOrder(u) = 1 THEN
					R$ = "10"
				ELSEIF uOrder(u) = 4 THEN
					R$ = "5"
				ELSE
					R$ = "5*mps"
				END IF
				D2$ = "|Recovers " + R$ + "% effectiveness"
				m$ = D1$ + D2$
				CALL MESSAGE(m$, MSGSECS)
			END IF
		END IF
	NEXT u
skiprecovery:

	'**Start new player
	cPLAYER = cPLAYER XOR 1
	IF cPLAYER = GERMAN THEN TURN = TURN + 1
	CALL Reinforcements
	Mode = 0
	Phase = 1
	FOR u = 1 TO nUnits
		IF Player(u) = cPLAYER THEN
			sHEX(u) = UnitY(u) * 100 + UnitX(u)
			IF orderEFF(uOrder(u), UT(u), 1) = -1 THEN
				mps(u) = -1
			ELSE
				mps(u) = ma(u) * orderEFF(uOrder(u), UT(u), 1) / 100
			END IF
		END IF
	NEXT u

END SUB

SUB ProcesMenu (X, event$)
	
	IF X = -1 THEN
		Choice = VAL(event$)
	ELSE
		Choice = MIN(X / 80 + 1, nSubm(0))
		CALL MenuGet(Choice)
	END IF

	SELECT CASE Choice
	CASE 11
		CALL GameNew
		MapDraw
	CASE 12
		'** Load
		CALL GameLoad
	CASE 13
		'** SAVE
		GameSave
	CASE 14
		ColorList
	CASE 15
		CALL GameQuit
	CASE 21
		'** Next PHASE
		ActiveUnit = 0
		Phase = Phase + 1
		'  phase = 1                         Orders phase
		IF Phase = 2 THEN PlayerActionPhase 'Action phase
		IF Phase = 3 THEN
			IF cPLAYER <> GERMAN THEN
				IF VictoryCheck% THEN
					DIM t$(4), B$(2)
					t$(1) = "    German Victory!     "
					t$(3) = "    Start New Game?   "
					B$(1) = "NEW GAME"
					B$(2) = "  QUIT  "
					CALL Alert(t$(), B$(), 0, 0, C)
					IF C = 1 THEN
						CALL GameNew
					ELSE
						CALL GameQuit
					END IF
				ELSEIF TURN = 6 THEN
					DIM t$(4), B$(2)
					t$(1) = "    Russian Victory!   "
					t$(3) = "     Start New Game?   "
					B$(1) = "NEW GAME"
					B$(2) = "  QUIT  "
					CALL Alert(t$(), B$(), 0, 0, C)
					IF C = 1 THEN
						CALL GameNew
					ELSE
						CALL GameQuit
					END IF
				ELSE
					'** Else continue game with next player
					CALL PlayerNext
				END IF
			ELSE
				CALL PlayerNext   'Next player
			END IF
		END IF
		MapDraw
		BEEP
	CASE 22
		'**
		CALL ArmyOrders(cPLAYER)
	CASE 23
		n = VictoryCheck%
	CASE 31
		IF CenterDots = TRUE THEN
			submenu(3, 1) = "Dots are OFF": CenterDots = FALSE
		ELSE
			submenu(3, 1) = "Dots are ON": CenterDots = TRUE
		END IF
		MapDraw
	CASE 32
		IF HEXs = TRUE THEN
			submenu(3, 2) = "HEXs are OFF": HEXs = FALSE
		ELSE
			submenu(3, 2) = "HEXs are ON": HEXs = TRUE
		END IF
		MapDraw
	CASE 33
		IF HexNumbers = TRUE THEN
			submenu(3, 3) = "Nums are OFF": HexNumbers = FALSE
		ELSE
			submenu(3, 3) = "Nums are ON": HexNumbers = TRUE
		END IF
		MapDraw
	CASE 34
		IF EZOC = TRUE THEN
			submenu(3, 4) = "EZOC is  OFF": EZOC = FALSE
		ELSE
			submenu(3, 4) = "EZOC is   ON": EZOC = TRUE
		END IF
		MapDraw
	CASE 35
		IF MoveArea = TRUE THEN
			submenu(3, 4) = "Move areaOFF": MoveArea = FALSE
		ELSE
			submenu(3, 4) = "Move area ON": MoveArea = TRUE
		END IF
		MapDraw
	CASE 41
		CALL HelpTerrain
	CASE 42
		CALL HelpOrders
	CASE 43
		'help
		HelpTopic
	CASE 44
		CALL Credits
	CASE 45
		CALL MSGLENGTH
	CASE 46
		DIM t$(7), B$(1)
		t$(1) = "       Victory Conditions"
		t$(2) = "   "
		t$(3) = "The German player must have the"
		t$(4) = "the three hex city (1526, 1427,"
		t$(5) = "and 1527) in their ZOC by the"
		t$(6) = "end of turn 6 to win or they lose."
		t$(7) = ""
		B$(1) = "  OK  "
		CALL Alert(t$(), B$(), 0, 0, C)
	CASE ELSE
		'Future.Print 0, 583, submenu(INT(Choice / 10), Choice MOD 10), RED, BLACK
		'Future.Print 100, 583, STR$(Choice) + "  ", RED, BLACK
	END SELECT

END SUB

SUB ProcessKeyBoard (k, event$)
	STATIC OldX, OldY
	 
	CALL ShiftStatus(s)
	IF s AND 8 THEN
		CALL SetLocation(8, 20)
		CALL ProcesMenu(8, event$)
		k = -1
	END IF

	SELECT CASE k
	CASE -1  'No key
	CASE ESC
		CALL ProcesMenu(-1, STR$(15))
	CASE HOME: HY = 0: HX = 0
	CASE ENDKEY: HY = maxY: HX = maxX
	CASE PGDN: HY = HY + bigstep
	CASE PGUP: HY = HY - bigstep
	CASE UP: HY = HY - smallstep
	CASE DOWN: HY = HY + smallstep
	CASE RIGHT: HX = HX + smallstep
	CASE left: HX = HX - smallstep
	CASE TABKEY: HX = HX + bigstep
	CASE SHIFTTAB: HX = HX - bigstep           'Shift Tab
	CASE 32 'space
	CASE 65
		CALL ProcesMenu(-1, STR$(22))
	CASE 1059 'F1
		CALL ProcesMenu(-1, STR$(43))
	CASE 1060 'F2
		CALL ProcesMenu(-1, STR$(21))
	CASE 1062 'F4
		CALL ProcesMenu(-1, STR$(12))
	CASE 1063 'F5
		CALL ProcesMenu(-1, STR$(13))
	CASE 1064 'F6
		CALL ProcesMenu(-1, STR$(14))
	CASE 1065 'F7
	CASE 1066 'F8
	CASE ELSE
		'Future.PRINT 200, 583, "Key = " + RIGHT$("00" + STR$(k), 2) + "  ", WHITE, 0
	END SELECT

	HX = MAX(0, MIN(HX, maxX))
	HY = MAX(0, MIN(HY, maxY))

	IF OldX <> HX OR OldY <> HY THEN
		'***** Update Screen *******
		OldX = HX: OldY = HY
		MapDraw
	END IF
 
 
END SUB

SUB ProcessMouse (event$)
	 
	mx = Future.MouseX: my = Future.MouseY
	CALL MapPosition(mx, my, Col, row)
	MButton = Future.MouseB
	IF MButton = 0 THEN EXIT SUB
	IF MButton AND 2 AND row <> -1 THEN
		UnitGet Col, row, cUnit
		IF attack(cUnit) = -1 THEN
			CALL UnitCombat(cUnit)
		ELSEIF cUnit > 0 THEN UnitPopUp cUnit: UnitGet Col, row, cUnit
		END IF
		EXIT SUB
	END IF

	'** else MB=1
	IF INBOX(mx, my, px1, py1, px2, py2) THEN
		IF NOT INBOX(Col, row, 0, 0, TotalX - 1, TotalY - 1) THEN EXIT SUB
		UnitGet Col, row, cUnit
		IF Mode = 0 THEN
			ActiveUnit = cUnit
			MapDraw
		ELSEIF Mode = 1 THEN
			IF cPLAYER = Player(cUnit) THEN
				IF mps(cUnit) <> 0 THEN
					ActiveUnit = cUnit
					Mode = 2
					CALL UnitMoveZone(cUnit, UnitX(cUnit), UnitY(cUnit))
					MapDraw
				END IF
			END IF
		ELSEIF Mode = 2 THEN
			UnitGet Col, row, cUnit
			IF cUnit > 0 THEN
				IF cPLAYER = Player(cUnit) THEN
					'** New unit selected
					ActiveUnit = cUnit
					Mode = 2
				ELSEIF (cPLAYER XOR 1) = Player(cUnit) THEN
					IF ADJACENT(UnitX(ActiveUnit), UnitY(ActiveUnit), UnitX(cUnit), UnitY(cUnit)) THEN
						IF mps(ActiveUnit) >= 2 THEN
							mps(ActiveUnit) = mps(ActiveUnit) - 2
							attack(cUnit) = -1
							attack(ActiveUnit) = CalcDir(UnitX(ActiveUnit), UnitY(ActiveUnit), UnitX(cUnit), UnitY(cUnit))
							attack(ActiveUnit) = attack(ActiveUnit) + cUnit * 64
						ELSEIF mps(ActiveUnit) - 1 THEN
							mps(ActiveUnit) = 0
							attack(cUnit) = -1
							attack(ActiveUnit) = CalcDir(UnitX(ActiveUnit), UnitY(ActiveUnit), UnitX(cUnit), UnitY(cUnit))
							attack(ActiveUnit) = attack(ActiveUnit) + cUnit * 64
						ELSE
							BEEP
						END IF
					END IF
				END IF
			ELSEIF move(Col, row) < 0 THEN
				'** no unit, illegal move, go back to selection mode
				BEEP
				ActiveUnit = 0: Mode = 1
			ELSEIF move(Col, row) > -1 THEN
				'** legal move
				IF ActiveUnit < 1 THEN EXIT SUB
				UnitX(ActiveUnit) = Col: UnitY(ActiveUnit) = row
				mps(ActiveUnit) = INT(move(Col, row) / 2)
				IF mps(ActiveUnit) = 0 THEN ActiveUnit = 0: Mode = 1
				attack(ActiveUnit) = 0
			END IF
			CALL UnitMoveZone(ActiveUnit, UnitX(ActiveUnit), UnitY(ActiveUnit))
			MapDraw
		ELSEIF Mode = 3 THEN
			'** add attackers
		ELSEIF Mode = 4 THEN
			'** retreating
			IF move(Col, row) > -1 THEN
				'** legal retreat
				IF ActiveUnit < 1 THEN EXIT SUB
				UnitX(ActiveUnit) = Col: UnitY(ActiveUnit) = row
				mps(ActiveUnit) = 0
				attack(ActiveUnit) = 0
				ActiveUnit = 0: Mode = 1
				UnitMoveZone 0, 0, 0
			ELSEIF UnitX(ActiveUnit) = Col AND UnitY(ActiveUnit) = row THEN
				'** Standfast
				str(ActiveUnit) = str(ActiveUnit) - 1
				IF INT(10 * RND) > skill(ActiveUnit) THEN
					'** unit fails skill test and takes a extra lost
					str(ActiveUnit) = str(ActiveUnit) - 1
					MESSAGE desgn$(ActiveUnit) + " takes a |extra step loss", MSGSECS
				END IF
				IF str(ActiveUnit) < 1 THEN
					unittype(ActiveUnit) = 0
					UnitX(ActiveUnit) = -1
					UnitY(ActiveUnit) = -1
				END IF
				mps(ActiveUnit) = 0
				attack(ActiveUnit) = 0
				ActiveUnit = 0: Mode = 1
				UnitMoveZone 0, 0, 0
			ELSE
				DIM t$(4), B$(1)
				t$(1) = "Click on the retreating Unit "
				t$(2) = "to standfast, or on a high-"
				t$(3) = "lighted hex to retreat."
				B$(1) = "  OK  "
				CALL Alert(t$(), B$(), 0, 0, C)
			END IF
			MapDraw
		END IF
	ELSEIF INBOX(mx, my, 656, 0, 800, 16) THEN
		CALL ProcesMenu(-1, STR$(21))
	ELSEIF INBOX(mx - px2, my - py1, 0, 0, SLIDERW, py2) THEN
		'*** Vertical slider ********************
		ww! = (py2 - py1) / (cellsizeY * TotalY) * (py2 - py1)
		VPOS = ((py2 - py1 - ww!) / maxY) * HY
		NY = my - py1
		IF NY < VPOS THEN HY = 1! * maxY * NY / (py2 - py1 - ww!)
		IF NY > VPOS + ww! THEN HY = 1! * maxY * (NY - ww!) / (py2 - py1 - ww!)
		MapDraw
	ELSEIF INBOX(mx - px1, my - py2, 0, 0, px2, SLIDERW) THEN
		'*** Horizontal slider ********************
		ww! = (px2 - px1) / (cellsizeX * TotalX) * (px2 - px1)
		HPOS = px1 + ((px2 - px1 - ww!) / maxX) * HX
		NX = mx - px1
		IF NX < HPOS THEN HX = 1! * maxX * NX / (px2 - px1 - ww!)
		IF NX > HPOS + ww! THEN HX = 1! * maxX * (NX - ww!) / (px2 - px1 - ww!)
		MapDraw
	ELSEIF INBOX(mx, my, 0, 0, 320, 16) THEN
		CALL ProcesMenu(mx, event$)
	ELSE
	END IF
 
	DO: LOOP UNTIL Future.MouseB = 0


END SUB

SUB TerrainAssign (n, n$, Foot, Mech, Mobile, inf, arm, first, damageMod)

	tname(n) = n$
	Foot(n) = Foot
	Mech(n) = Mech
	Mobile(n) = Mobile
	inf(n) = inf
	arm(n) = arm
	first(n) = first
	damMod(n) = damageMod
END SUB

SUB TerrainCost (X1, Y1, dir, u, cost)

	MoveDir dir, X1, Y1, x2, y2
	IF NOT INBOX(x2, y2, 0, 0, TotalX - 1, TotalY - 1) THEN cost = -1: EXIT SUB

	IF unittype(u) = 3 OR unittype(u) = 5 THEN
		'** Infantry
		cost = Foot(map(x2, y2)) * 2
		IF river(X1, Y1) AND dir THEN cost = cost + 1 * 2
		IF road(X1, Y1) AND dir THEN cost = 1
	ELSEIF uOrder(u) = 3 THEN
		'** mechanized in march mode
		cost = Mobile(map(x2, y2)) * 2
		IF river(X1, Y1) AND dir THEN cost = cost + 2 * 2
		IF road(X1, Y1) AND dir THEN cost = 1
	ELSE
		'** mechanized deployed
		cost = Mech(map(x2, y2)) * 2
		IF river(X1, Y1) AND dir THEN cost = cost + 1 * 2
	END IF

	IF zoc(X1, Y1) AND zoc(x2, y2) THEN
		cost = 100
	ELSEIF zoc(X1, Y1) THEN
		cost = cost + 2 * 2
	END IF

END SUB

SUB UnitArrow (u)
 
	row = UnitY(u)
	Col = UnitX(u)
	Y1 = row * cellsizeY - HY + py1
	X1 = Col * cellsizeX + px1 - HX - ((row + 1) MOD 2) * cellsizeX / 2

	SetMaskColor BLACK
	SELECT CASE attack(u) MOD 64
	CASE 0
	CASE 1
		Future.PUT X1 + 45, Y1 + 15, a1()
	CASE 2
		Future.PUT X1 + 31, Y1 - 12, a2()
	CASE 4
		Future.PUT X1 - X, Y1 - 12, a4()
	CASE 8
		Future.PUT X1 - 15, Y1 + 15, a8()
	CASE 16
		Future.PUT X1 - 5, Y1 + 40, a16()
	CASE 32
		Future.PUT X1 + 26 + X, Y1 + 40, a32()
	CASE ELSE
	END SELECT
	SetMaskColor -1

END SUB

SUB UnitAssign (u, s, a, d$, UT, f, MP, eff, hex)

	'** There are six unittypes for symbols but only four for orders
	unittype(u) = s
	UT(u) = UT
	army(u) = a
	desgn$(u) = d$
	str(u) = f
	ma(u) = MP
	UnitX(u) = hex MOD 100
	UnitY(u) = hex \ 100
	skill(u) = eff
	uOrder(u) = aOrders(a)
	effectiveness(u) = 100
	attack(u) = 0

END SUB

SUB UnitCombat (u)

	DIM attackers(6)
	FOR i = 1 TO nUnits
		IF INT(attack(i) / 64) = u THEN k = k + 1
	NEXT i
	DIM t$(7 + k), B$(3)

	FOR i = 1 TO nUnits
		IF INT(attack(i) / 64) = u THEN
			nAttackers = nAttackers + 1
			attackers(nAttackers) = i
			AF = UnitOffFire(i)
			Offense = Offense + AF
			IF AF > MaxAF THEN MaxAF = AF: MaxATT = i
			t$(nAttackers + 6) = "1234567890123=567*901*345"
			t$(nAttackers + 6) = "           OF=str*..0*..0"
			MID$(t$(nAttackers + 6), 1, 10) = desgn$(i)
			MID$(t$(nAttackers + 6), 11, 3) = RIGHT$("   " + STR$(UnitOffFire(i)), 3)
			MID$(t$(nAttackers + 6), 15, 3) = RIGHT$("   " + STR$(str(i)), 3)
			MID$(t$(nAttackers + 6), 19, 3) = LTRIM$(RIGHT$(STR$(effectiveness(i) / 100!), 3))
			MID$(t$(nAttackers + 6), 23, 3) = LTRIM$(RIGHT$(STR$(orderEFF(uOrder(i), UT(i), 2) / 100!), 3))
		END IF
	NEXT i
 
	'** Calc Defensive Fire Value
	IF unittype(u) = 3 OR unittype(u) = 5 THEN
		'** Infantry
		terrainValue! = inf(map(UnitX(u), UnitY(u))) / 100!
	ELSE
		terrainValue! = arm(map(UnitX(u), UnitY(u))) / 100!
	END IF
	tr$ = STR$(terrainValue)
	t$(5) = "           DF=str*..0*..0*..0"
	MID$(t$(5), 1, 10) = desgn$(u)
	MID$(t$(5), 11, 3) = RIGHT$("   " + STR$(UnitDefFire(u)), 3)
	MID$(t$(5), 15, 3) = RIGHT$("   " + STR$(str(u)), 3)
	MID$(t$(5), 19, 3) = LTRIM$(RIGHT$(STR$((effectiveness(u) + 100!) / 200!), 3))
	MID$(t$(5), 23, 3) = LTRIM$(RIGHT$(STR$(orderEFF(uOrder(u), UT(u), 3) / 100!), 3))
	MID$(t$(5), 27, 3) = LTRIM$(RIGHT$(STR$(terrainValue!), 3))

	t$(1) = "    Execute Attack Now?   "
	t$(2) = ""
	t$(3) = "Defender =" + RIGHT$("  " + STR$(UnitDefFire(u)), 3)
	IF UnitFirstFire(u) THEN t$(3) = t$(3) + " (1st Fire)"
	t$(4) = "Attacker =" + STR$(Offense)

	B$(1) = "ATTACK!"
	B$(2) = " WAIT  "
	B$(3) = " CANCEL"

	CALL Alert(t$(), B$(), 0, 0, C)
	
	IF C = 1 THEN '** ATTACK!
		IF UnitFirstFire(u) THEN
			CALL FIRE(UnitDefFire(u), skill(u), MaxATT, dam1, disrupt1)
			CALL UnitResults(MaxATT, dam1, disrupt1)
			Offense = 0
			FOR i = 1 TO nAttackers
				AF = UnitOffFire(attackers(i))
				Offense = Offense + AF
				AvgP = AvP + skill(i)
			NEXT i
			AvgP = AvgP / nAttackers
			CALL FIRE(Offense, AvgP, u, dam2, disrupt2)
			CALL UnitResults(u, dam2, disrupt2)
		ELSE
			CALL FIRE(UnitDefFire(u), skill(u), MaxATT, dam1, disrupt1)
			Offense = 0
			FOR i = 1 TO nAttackers
				AF = UnitOffFire(attackers(i))
				Offense = Offense + AF
				AvgP = AvgP + skill(i)
			NEXT i
			AvgP = AvgP / nAttackers
			CALL FIRE(Offense, AvgP, u, dam2, disrupt2)
			CALL UnitResults(MaxATT, dam1, disrupt1)
			CALL UnitResults(u, dam2, disrupt2)
		END IF

		'**   Determine whether defender retreats ***********
		'**   depending on orders and losses
		attack(u) = 0
		IF uOrder(u) = 1 THEN
			'** Must Hold
			IF dam2 * disrupt2 > dam1 * disrupt1 * 4 THEN
				UnitRetreat u
			ELSEIF dam2 * disrupt2 > dam1 * disrupt1 * 2 THEN
				IF str(u) > 2 THEN
					str(u) = str(u) - 1
					MESSAGE desgn$(u) + " takes a step loss |rather than retreat", MSGSECS
				ELSE
					'** retreat not necessary
				END IF
			END IF
		ELSEIF uOrder(u) = 3 THEN
			'** Mobile
			IF dam2 > 0 THEN
				str(u) = str(u) + 1
				MESSAGE desgn$(u) + " avoids a step loss |by retreating", MSGSECS
				UnitRetreat u
			ELSEIF dam2 * disrupt2 * 2 > dam1 * disrupt1 THEN
				UnitRetreat u
			END IF
		ELSE
			'** Defend or Assault
			IF dam2 * disrupt2 > dam1 * disrupt1 THEN UnitRetreat u
		END IF
	 
		FOR i = 1 TO nAttackers
			attack(attackers(i)) = 0
			IF attackers(i) <> MaxATT THEN
				effectiveness(attackers(i)) = MAX(effectiveness(attackers(i)) - disrupt1, 0)
			END IF
		NEXT i
		CALL UnitMoveZone(ActiveUnit, UnitX(ActiveUnit), UnitY(ActiveUnit))
		MapDraw
	ELSEIF C = 3 THEN
		attack(u) = 0
		FOR i = 1 TO nAttackers
			attack(attackers(i)) = 0
		NEXT i
		MapDraw
	END IF

END SUB

FUNCTION UnitDefFire (u)

	'DF = strength * (effectiveness + 1) / 2 * terrain * Orders
	IF unittype(u) = 3 OR unittype(u) = 5 THEN
		'** Infantry
		terrainValue = inf(map(UnitX(u), UnitY(u)))
	ELSE
		terrainValue = arm(map(UnitX(u), UnitY(u)))
	END IF
	modifier! = (effectiveness(u) + 100) / 200! * terrainValue / 100!
	modifier! = modifier! * orderEFF(uOrder(u), UT(u), 3) / 100
	UnitDefFire = INT(str(u) * modifier! + .5)


END FUNCTION

SUB UnitDraw (u)

	IF unittype(u) = 0 THEN EXIT SUB
	Future.MouseOff
	row = UnitY(u)
	Col = UnitX(u)
	Y1 = aHex - 1 + row * cellsizeY - HY + py1
	X1 = aHex - 1 + Col * cellsizeX + px1 - HX - ((row + 1) MOD 2) * cellsizeX / 2
	UnitText& = BLACK
	SELECT CASE unittype(u)
	CASE 0
	CASE 1: Future.PUT X1, Y1, U1()
	CASE 2: Future.PUT X1, Y1, U2(): UnitText& = WHITE
	CASE 3: Future.PUT X1, Y1, U3()
	CASE 4: Future.PUT X1, Y1, U4()
	CASE 5: Future.PUT X1, Y1, U5()
	CASE 6: Future.PUT X1, Y1, U6()
	CASE ELSE
	END SELECT

	Z1 = X1 + 22: Z2 = Y1 + 5
	IF army(u) >= 10 THEN SetMaskColor 0
	SELECT CASE army(u)
	CASE 1: Future.PUT Z1, Z2, r1()
	CASE 2: Future.PUT Z1, Z2, r2()
	CASE 3: Future.PUT Z1, Z2, r3()
	CASE 4: Future.PUT Z1, Z2, r4()
	CASE 5: Future.PUT Z1, Z2, r5()
	CASE 6: Future.PUT Z1, Z2, r6()
	CASE 7: Future.PUT Z1, Z2, r7()
	CASE 8: Future.PUT Z1, Z2, r8()
	CASE 10: Future.PUT Z1, Z2, g1()
	CASE 11: Future.PUT Z1, Z2, g2()
	CASE 12: Future.PUT Z1, Z2, g3()
	CASE 13: Future.PUT Z1, Z2, g4()
	CASE 14: Future.PUT Z1, Z2, g5()
	CASE 15: Future.PUT Z1, Z2, g6()
	CASE ELSE
	END SELECT
	SetMaskColor -1

	IF effectiveness(u) <= 70 THEN UnitText& = RED
	IF cPLAYER = Player(u) THEN
		u$ = LTRIM$(STR$(str(u))) + "-" + LTRIM$(STR$(ABS(mps(u))))
		Y1 = row * cellsizeY - HY + py1
		Tx = X1 + (40 - LEN(u$) * 8) / 2
		Future.PRINT Tx, Y1 + cellsizeY - 20, u$, UnitText&, -1
		IF mps(u) = -1 THEN
			Future.PRINT Tx + LEN(u$) * 8 - 8, Y1 + cellsizeY - 20, "1", RED, -1
		END IF
	ELSE
		DF = INT(str(u) * orderEFF(uOrder(u), UT(u), 3) / 100)
		DF = INT(str(u))
		u$ = LTRIM$(STR$(DF))
		Y1 = row * cellsizeY - HY + py1
		Tx = X1 + (40 - LEN(u$) * 8) / 2
		Future.PRINT Tx, Y1 + cellsizeY - 20, u$, UnitText&, -1
	END IF
 
	bx = X1 - 2: by = Y1 + 2: w = 45
	IF u = ActiveUnit THEN
		Future.BOX bx, by, bx + w, by + w, RED
		Future.BOX bx + 1, by + 1, bx + w - 1, by + w - 1, RED
	END IF
	IF attack(u) = -1 THEN
		Future.CIRCLE bx + 22, by + 22, 24, RED
	END IF
	Future.MouseOn

END SUB

FUNCTION UnitFirstFire (u)
 
IF map(UnitX(u), UnitY(u)) = 2 THEN
		UnitFirstFire = FALSE
	ELSEIF map(UnitX(u), UnitY(u)) = 9 THEN
		UnitFirstFire = FALSE
	ELSE
		UnitFirstFire = TRUE
	END IF
 
	IF first(map(UnitX(u), UnitY(u))) = 1 THEN
		UnitFirstFire = FALSE
	ELSE
		UnitFirstFire = TRUE
	END IF
 
END FUNCTION

SUB UnitGet (X, Y, unit)
	unit = 0
	UX = 480: UY = 32
	FOR u = 1 TO nUnits
		IF UnitX(u) = X AND UnitY(u) = Y THEN
			unit = u
			EXIT FOR
		END IF
	NEXT u
	IF unit = 0 THEN EXIT SUB
	IF unittype(unit) = 0 THEN EXIT SUB

	d$ = desgn$(unit) + "/" + army$(army(unit)) + " {" + RTRIM$(ordertext(uOrder(unit))) + "}"
	d$ = d$ + SPACE$(40 - LEN(d$))
	Future.PRINT UX, UY, d$, WHITE, BLACK
 
	Future.PRINT UX, UY + 16, "skill:" + STR$(skill(unit)), BLACK, RED
 
	s$ = " Effective " + STR$((effectiveness(unit))) + "  "
	Future.PRINT UX + 8 * 8, UY + 16, s$, BLACK, RED
 
	s$ = "Raw strength/Attack/Defense AA/BB/CC"
	MID$(s$, INSTR(s$, "AA"), 2) = RIGHT$(STR$(str(unit)), 2)
	MID$(s$, INSTR(s$, "BB"), 2) = RIGHT$(STR$(UnitOffFire(unit)), 2)
	MID$(s$, INSTR(s$, "CC"), 2) = RIGHT$(STR$(UnitDefFire(unit)), 2)
	Future.PRINT UX, UY + 32, s$, WHITE, BLACK

END SUB

SUB UnitMoveZone (u, UX, UY)

	FOR Y = 0 TO TotalY - 1
		FOR X = 0 TO TotalX - 1
			move(X, Y) = -1
			zoc(X, Y) = 0
		NEXT X
	NEXT Y
 
	IF u = 0 OR unittype(u) = 0 THEN
		enemy = cPLAYER XOR 1
	ELSE
		enemy = Player(u) XOR 1
	END IF

	FOR i = 1 TO nUnits
		IF unittype(i) = 0 THEN
			'** unit not in play
		ELSEIF Player(i) = enemy THEN
			zoc(UnitX(i), UnitY(i)) = TRUE
			FOR k = 1 TO 6
				MoveDir dir(k), UnitX(i), UnitY(i), dx, dy
				IF INBOX(dx, dy, 0, 0, TotalX - 1, TotalY - 1) THEN zoc(dx, dy) = TRUE
			NEXT k
		END IF
	NEXT i
 
	IF mps(u) = 0 THEN EXIT SUB
 
	IF mps(u) = -1 THEN
		'** One hex
		FOR i = 1 TO 6
			MoveDir dir(i), UX, UY, dx, dy
			IF INBOX(dx, dy, 0, 0, TotalX - 1, TotalY - 1) THEN
				CALL TerrainCost(UX, UY, dir(i), u, cost)
				move(dx, MAX(dy, 0)) = 0
				IF cost = 100 THEN move(dx, dy) = -1
			END IF
		NEXT i
		EXIT SUB
	END IF
 
	move(UX, UY) = mps(u) * 2
	DO
	DONE = TRUE
	FOR Y = 0 TO TotalY - 1
		FOR X = 0 TO TotalX - 1
			IF move(X, Y) > 0 THEN
				FOR i = 1 TO 6
					MoveDir dir(i), X, Y, dx, dy
					CALL TerrainCost(X, Y, dir(i), u, cost)
					t = move(X, Y) - cost
					IF cost = -1 THEN
					ELSEIF t < 0 THEN
					ELSEIF t > move(dx, dy) THEN
						move(dx, dy) = t
						DONE = FALSE
					END IF
				NEXT i
			END IF
		NEXT X
	NEXT Y
	LOOP UNTIL DONE
 
	'**  can always move one hex
	IF sHEX(u) = UY * 100 + UX THEN
		FOR i = 1 TO 6
			MoveDir dir(i), UX, UY, dx, dy
			IF INBOX(dx, dy, 0, 0, TotalX - 1, TotalY - 1) THEN
				IF move(dx, dy) = -1 THEN
					CALL TerrainCost(UX, UY, dir(i), u, cost)
					move(dx, dy) = 0
					IF cost = 100 THEN move(dx, dy) = -1
				END IF
			END IF
		NEXT i
	END IF

END SUB

FUNCTION UnitOffFire (u)
 
	'OF = strength * effectiveness * terrain * Orders
	dir = attack(u) MOD 64
	
	IF river(UnitX(u), UnitY(u)) AND dir THEN
		terrainValue = 80
	ELSE
		terrainValue = 100
	END IF
	modifier! = (effectiveness(u) / 100!) * terrainValue / 100!
	modifier! = modifier! * orderEFF(uOrder(u), UT(u), 2) / 100
	UnitOffFire = INT(str(u) * modifier!)

END FUNCTION

SUB UnitPopUp (u)
	SetViewPort 0, 0, 800, 600
	TempScreen = AllocateXMS(480000) 'get 256000 bytes of XMS memory
	Future.MouseOff
	Future.XMSget 0, 0, 800, 600, TempScreen

	
	w = 180: H = 166
	by = UnitY(u) * cellsizeY - HY + py1
	bx = UnitX(u) * cellsizeX + px1 - HX - ((UnitY(u) + 1) MOD 2) * cellsizeX / 2
 
	Future.BOX bx + 3, by + 3, bx + 46, by + 46, RED
	Future.BOX bx + 4, by + 4, bx + 45, by + 45, RED

	IF bx + w + cellsizeX > px2 THEN
		bx = bx - w - 10
	ELSE
		bx = bx + cellsizeX
	END IF
	IF by + H + 10 > py2 THEN
		by = by - H + 10
	ELSE
		by = by + 10
	END IF
	SetViewPort bx, by, bx + w + 1, by + H + 1
	Future.FILLBOX bx, by, bx + w, by + H, 29
	Future.BOX bx, by, bx + w, by + H, BLACK
	Future.PRINT bx + 4, by + 2, desgn$(u), BLACK, -1
	Future.PRINT bx + 4, by + 18, army$(army(u)), BLACK, -1
	s$ = RTRIM$(ordertext(uOrder(u)))
	s$ = s$ + " AF X" + STR$(orderEFF(uOrder(u), UT(u), 2)) + "%"
	Future.PRINT bx + 4, by + 34, s$, BLACK, -1
	Future.PRINT bx + 4, by + 52, "skill:" + STR$(skill(u)), BLACK, RED
	IF cPLAYER = Player(u) THEN
		GOSUB printOrders
		SetViewPort 0, 0, 800, 600

		Future.MouseOn
		DO: Future.UpdateMouse: LOOP UNTIL Future.MouseB = 0
		DO
			Future.UpdateMouse
			IF Future.MouseB AND 1 THEN
				mx = Future.MouseX
				my = Future.MouseY
				IF INBOX(mx, my, bx, Ty, bx + w, by + H) THEN
					IF army(u) < 10 THEN Warning = TRUE: EXIT DO
					uOrder(u) = MIN(INT((my - Ty) / 16), 4)
					IF orderEFF(uOrder(u), UT(u), 1) = -1 THEN
						mps(u) = -1
					ELSE
						mps(u) = ma(u) * orderEFF(uOrder(u), UT(u), 1) / 100
					END IF
					Future.MouseOff
					GOSUB printOrders
					Future.MouseOn
					DO: Future.UpdateMouse: LOOP UNTIL Future.MouseB = 0
					EXIT DO
				ELSE
					EXIT DO
				END IF
			END IF
		LOOP
	ELSE
		Ty = by + 74
		IF unittype(u) = 3 OR unittype(u) = 5 THEN
			'** Infantry
			terrainValue = inf(map(UnitX(u), UnitY(u)))
		ELSE
			terrainValue = arm(map(UnitX(u), UnitY(u)))
		END IF
		Future.PRINT bx + 4, by + 74, "Raw Str:" + STR$(str(u)), BLACK, -1
		s$ = "Terrain X" + STR$(terrainValue / 100!)
		Future.PRINT bx + 4, Ty + 16, s$, BLACK, -1
		s$ = "Orders X" + STR$(orderEFF(uOrder(u), UT(u), 3) / 100!)
		Future.PRINT bx + 4, Ty + 32, s$, BLACK, -1
		s$ = "Disruption X" + STR$((effectiveness(u) + 100) / 200!)
		Future.PRINT bx + 4, Ty + 48, s$, BLACK, -1
		s$ = "DF Value" + STR$(UnitDefFire(u))
		Future.PRINT bx + 4, Ty + 64, s$, BLACK, RED
		SetViewPort 0, 0, 800, 600
	 
		DO: LOOP UNTIL Future.MouseB = 0
		CALL anykey
	END IF

	Future.MouseOff
	Future.XMSput 0, 0, TempScreen
	DeallocateXMS TempScreen 'free up XMS memory
	DO: LOOP UNTIL INKEY$ = ""   '** Clear inkey buffer
	Future.MouseOn
	MapDraw

	IF Warning = TRUE THEN
		DIM t$(8), B$(1)

		t$(1) = "          Notice!  "
		t$(2) = "Due to the command limitations"
		t$(3) = "of this Army all units of a "
		t$(4) = "given Army must share the "
		t$(5) = "same orders.  Therefore"
		t$(6) = "orders may only be changed"
		t$(7) = "through the army menu  "
		B$(1) = "  OK  "
		CALL Alert(t$(), B$(), 0, 0, C)
	END IF

EXIT SUB

printOrders:
	Future.PRINT bx + 4, by + 68, "Raw Str:" + STR$(str(u)), BLACK, -1
	s$ = "Effectiveness X " + FORM$((effectiveness(u)) / 100, 2)
	Future.PRINT bx + 4, by + 84, s$, BLACK, -1
 
	Ty = by + 84
	FOR i = 1 TO 4
		background& = -1: IF uOrder(u) = i THEN background& = RED
		s$ = SPACE$(14)
		MID$(s$, 1) = LTRIM$(ordertext(i))
		Future.PRINT bx + 4, Ty + 16 * i, s$, BLACK, background&
	NEXT i
RETURN

END SUB

SUB UnitResults (u, damage, disruption)
 
	str(u) = str(u) - damage
	str(u) = MAX(str(u), 0)
	effectiveness(u) = effectiveness(u) - disruption
	effectiveness(u) = MAX(effectiveness(u), 0)
 
	IF str(u) = 0 THEN
		unittype(u) = 0: UnitX(u) = -1: UnitY(u) = -1
	END IF
END SUB

SUB UnitRetreat (u)
 
	IF unittype(u) = 0 THEN EXIT SUB
	Mode = 4
	CALL UnitGet(UnitX(u), UnitY(u), u)
	mps(u) = -1
	ActiveUnit = u
	CALL UnitMoveZone(u, UnitX(u), UnitY(u))
	MapDraw

END SUB

