DECLARE SUB anykey ()
DECLARE FUNCTION GETINKEY% ()
DECLARE FUNCTION BIN$ (n%)
DECLARE FUNCTION EXIST% (file$)
DECLARE FUNCTION MIN% (V1%, V2%)
DECLARE FUNCTION FORM$ (n!, d%)
DECLARE FUNCTION INBOX% (X%, Y%, X1%, Y1%, x2%, y2%)
DECLARE FUNCTION MAX% (V1%, V2%)
REM $INCLUDE: 'future.bi'
REM $DYNAMIC

DEFINT A-Z

  '********************* KeyBoard Constants ****************
  CONST left = 1075, RIGHT = 1077, PGDN = 1081, PGUP = 1073
  CONST UP = 1072, DOWN = 1080, ESC = 27, TABKEY = 9, CR = 13
  CONST HOME = 1071, ENDKEY = 1079, SHIFTTAB = 1015
  '****************  Color Constants ************************
  CONST BLACK = 0, WHITE = 4, RED = 3, DGREEN = 2, GREEN = 5, LTGREEN = 1
  CONST DBLUE = 6, BLUE = 7, LTBLUE = 8, LTGRAY = 9, GRAY = 10, DrGray = 11
  CONST YELLOW = 12, LtBrown = 13, Brown = 14
  '********************** Map Constants **************************
  '** Viewport size in pixels
  CONST px1 = 10, py1 = 100, px2 = 790, py2 = 570
  CONST bigstep = py2 - py1 - 10, smallstep = 50
  CONST SLIDERW = 8, nScreens = 4, xScreens = 2, yScreens = 2
  '************************ Logical Constants *******************
  CONST TRUE = -1, FALSE = 0
  CONST GERMAN = 0, RUSSIAN = 1

TYPE RegTypeX
  ax    AS INTEGER
  bx    AS INTEGER
  CX    AS INTEGER
  dx    AS INTEGER
  bp    AS INTEGER
  si    AS INTEGER
  di    AS INTEGER
  flags AS INTEGER
  ds    AS INTEGER
  es    AS INTEGER
END TYPE

DECLARE SUB InterruptX (intnum%, inreg AS RegTypeX, outreg AS RegTypeX)

REM $STATIC
SUB Alert (Text$(), Buttons$(), X, Y, ReturnButton)

  SetViewPort 0, 0, 800, 600
  TempScreen = AllocateXMS(480000) 'get 256000 bytes of XMS memory
  Future.MouseOff
  Future.XMSget 0, 0, 800, 600, TempScreen

  n = UBOUND(Text$, 1)              '*** Number of lines
  H = (n + 2) * 16                  '*** Height of box in pixels
  '** Find width of box in characters, min =20
  w = 20
  FOR I = 1 TO n
    w = MAX(LEN(Text$(I)) + 2, w)
  NEXT I
  bx = (800 - w * 8) / 2
  by = (600 - H) / 2
  Future.FILLBOX bx, by, bx + w * 8, by + H, BLACK
  Future.FILLBOX bx + 2, by + 2, bx + w * 8 - 2, by + H - 2, RED
  FOR I = 1 TO n
    Future.PRINT bx + 10, by - 6 + I * 16, Text$(I), WHITE, RED
  NEXT I
  nButtons = UBOUND(Buttons$, 1)
  '**= assumes all button lengths are the same
  bw = 8 * LEN(Buttons$(1))
  sp = (8 * w - nButtons * bw) / (nButtons + 1)
  by1 = by + H - 24
  by2 = by1 + 16

  Buttons$(0) = "Button0": ReturnButton = 0: DButton = 1
  GOSUB AlertKey
  Future.MouseOn

  DO
    k = GETINKEY: IF k > 0 THEN GOSUB AlertKey
    Future.UpdateMouse
    IF Future.MouseB AND 1 THEN
      mx = Future.MouseX
      my = Future.MouseY
      ReturnButton = 0
      '** Check to see if mouse is in button area
      IF INBOX(mx, my, bx + sp, by1, bx + w * 8 - sp, by2) THEN
        '** Calculated which button was pressed
        FOR I = 1 TO nButtons
          X1 = bx + (sp + bw) * I - bw
          x2 = bx + (sp + bw) * I
          IF INBOX(mx, my, X1, by1, x2, by2) THEN ReturnButton = I
        NEXT I
      END IF
    END IF
  LOOP UNTIL ReturnButton <> 0

  '** Clear input buffers
  DO: Future.UpdateMouse: LOOP UNTIL Future.MouseB = 0
  DO: LOOP UNTIL INKEY$ = ""   '** Clear inkey buffer

  Future.MouseOff
  Future.XMSput 0, 0, TempScreen
  DeallocateXMS TempScreen 'free up XMS memory
  Future.MouseOn

EXIT SUB

AlertKey:

  SELECT CASE k
  CASE ESC
    IF nButtons = 1 THEN ReturnButton = 1
    FOR I = 1 TO nButtons
      B$ = UCASE$(LTRIM$(RTRIM$(Buttons$(I))))
      IF B$ = "CANCEL" THEN ReturnButton = I
    NEXT I
  CASE TABKEY
    DButton = DButton + 1
    IF DButton > nButtons THEN DButton = 1
  CASE CR
    ReturnButton = DButton
  END SELECT

  FOR I = 1 TO nButtons
    IF I = DButton THEN
      dx = bx + sp + (bw + sp) * (I - 1)
      Future.PRINT dx, by1, Buttons$(I), RED, WHITE
      Future.BOX dx, by1, dx + 8 * LEN(Buttons$(I)) - 1, by1 + 15, BLACK
    ELSE
      Future.PRINT bx + sp + (bw + sp) * (I - 1), by1, Buttons$(I), RED, WHITE
    END IF
  NEXT I



RETURN

END SUB

SUB anykey

  DONE = FALSE
  DO
    Future.UpdateMouse
    IF Future.MouseB <> 0 THEN DONE = TRUE
    IF LEN(INKEY$) THEN DONE = TRUE
  LOOP UNTIL DONE
  DO: Future.UpdateMouse: LOOP UNTIL Future.MouseB = 0
  DO: LOOP UNTIL INKEY$ = ""   '** Clear inkey buffer

END SUB

FUNCTION BIN$ (n)

  s$ = "000000"
  t = 1
  FOR I = 1 TO 6
    IF n AND t THEN MID$(s$, 7 - I, 1) = "1"
    t = t * 2
  NEXT I
  BIN$ = s$

END FUNCTION

SUB ColorList

  SetViewPort 0, 0, 800, 600
  TempScreen = AllocateXMS(480000) 'get 256000 bytes of XMS memory
  Future.MouseOff
  Future.XMSget 0, 0, 800, 600, TempScreen
  Future.CLS WHITE
  w = 36: H = 32
  FOR X = 1 TO 20
    bx = 20 + X * w
    FOR Y = 1 TO 13
      by = 20 + Y * H
      Future.FILLBOX bx, by, bx + w, by + w, C
      Future.PRINT bx, by, STR$(C), BLACK, -1
      C = C + 1
      IF C = 256 THEN EXIT FOR
    NEXT Y
  NEXT X
  Future.PRINT 300, 540, "Any button Exits", BLACK, WHITE

  Future.MouseOn
  anykey

  Future.MouseOff
  Future.XMSput 0, 0, TempScreen
  DeallocateXMS TempScreen 'free up XMS memory
  Future.MouseOn

END SUB

FUNCTION EXIST (file$)

  DIM reg AS RegTypeX
  'get current DTA address
  reg.ax = &H2F00
  InterruptX &H21, reg, reg
  sgmt = reg.es
  ofst = reg.bx

  'set dta address
  dta$ = SPACE$(43)
  reg.ax = &H1A00
  reg.ds = VARSEG(dta$)
  reg.dx = SADD(dta$)
  InterruptX &H21, reg, reg

  ' Dose file exist ?
  path$ = file$ + CHR$(0)
  reg.ax = &H4E00
  reg.CX = 0
  reg.ds = VARSEG(path$)
  reg.dx = SADD(path$)
  InterruptX &H21, reg, reg
  IF reg.flags AND 1 THEN
    'file dose not exist
    EXIST = 0
  ELSE
    EXIST = -1
  END IF

  'restore dta address
  dta$ = SPACE$(43)
  reg.ax = &H1A00
  reg.ds = sgmt
  reg.dx = ofst
  InterruptX &H21, reg, reg


END FUNCTION

FUNCTION FORM$ (n!, d%)
  '** formats number to d% decimal places
  IF n! < 0 THEN
    sign$ = "-"
    n! = ABS(n!)
  ELSE
    sign$ = ""
  END IF

  IF n! * 10 ^ d% < 1 THEN
    FORM$ = sign$ + "0." + STRING$(d%, "0")
    EXIT FUNCTION
  END IF

  n# = n! * 10 ^ d% + .5
  n$ = STR$(n#)
  n$ = LTRIM$(RTRIM$(n$))
  IF INSTR(n$, ".") <> 0 THEN n$ = LEFT$(n$, INSTR(n$, ".") - 1)
  IF LEN(n$) <= d% THEN
    FORM$ = sign$ + "0." + STRING$(d% - LEN(n$), "0") + n$
  ELSE
    FORM$ = sign$ + LEFT$(n$, LEN(n$) - d%) + "." + RIGHT$(n$, d%)
  END IF

END FUNCTION

FUNCTION GETINKEY

    t$ = INKEY$
    t = LEN(t$)
    IF t = 0 THEN
      GETINKEY = -1
    ELSEIF t = 1 THEN
      GETINKEY = ASC(UCASE$(t$))
    ELSEIF t = 2 THEN
      GETINKEY = ASC(MID$(t$, 2, 1)) + 1000
    END IF

END FUNCTION

SUB GetPath (drive$, pp$)
  DIM regX AS RegTypeX

  IF drive$ = "" THEN
    regX.dx = 2
  ELSE
    regX.dx = ASC(UCASE$(drive$)) - 64
  END IF
  regX.ax = &H4700
  pp$ = SPACE$(64)
  regX.ds = VARSEG(pp$)
  regX.si = SADD(pp$)
  InterruptX &H21, regX, regX
  IF regX.flags AND 1 THEN
    'invalid drive
    pp$ = ""
  ELSE
    pp$ = LEFT$(pp$, INSTR(pp$, CHR$(0)) - 1)
  END IF

END SUB

SUB HelpTopic

  file$ = "Gamehelp.Txt"
  H = 20
  DIM Topics$(H), start(H)
  IF EXIST%(file$) THEN
    f = FREEFILE
    OPEN file$ FOR INPUT AS f
    H = 0: n = 0
    WHILE NOT (EOF(f))
      n = n + 1
      LINE INPUT #f, t$
      IF LEFT$(t$, 1) = "*" THEN
        H = H + 1
        start(H) = n
        Topics$(H) = t$
      END IF
    WEND
  ELSE
    EXIT SUB
  END IF

  nTopics = H - 1
  DIM a$(1000)
  FOR H = 1 TO nTopics
    a$(H) = Topics$(H)
  NEXT H
  a$(H + 1) = ""
  a$(H + 2) = ""
  H = H + 2
  mL = 60

  '** Go to beginning of file and read all lines into a$()
  SEEK #f, 1
  DO
    LINE INPUT #f, t$
    H = H + 1
    IF LEFT$(t$, 1) = "*" THEN
      a$(H) = t$
    ELSEIF LEN(t$) < mL THEN
      a$(H) = t$
    ELSE
      e = 0: s = 1
      DO
        '** Pharse text line
        e = e + mL
        e = INSTR(e, t$, " ")
        L = e - s
        H = H + 1
        IF L > 0 THEN
          a$(H) = LTRIM$(MID$(t$, s, L))
        ELSEIF LEN(t$) = 0 THEN
          a$(H) = ""
          EXIT DO
        ELSEIF e = 0 THEN
          a$(H) = MID$(t$, s, LEN(t$) - s + 1)
          EXIT DO
        ELSE
          a$(H) = "ERROR !!"
        END IF
        s = e + 1
      LOOP UNTIL s > LEN(t$)
    END IF
  LOOP UNTIL EOF(f)
  CLOSE f
  nText = H
  FOR H = 1 TO nText
    w = MAX(w, LEN(a$(H)))
  NEXT H

  SetViewPort 0, 0, 800, 600
  TempScreen = AllocateXMS(480000) 'get 256000 bytes of XMS memory
  Future.MouseOff
  Future.XMSget 0, 0, 800, 600, TempScreen

  '** draw textbox
  bx = 50: by = 50
  Future.FILLBOX bx, by, bx + w * 8 + 10, by + 27 * 16 + 10, WHITE
  bx = bx + 5: by = by + 5
  Future.PRINT bx + (w - LEN(file$)) * 4, by, file$, RED, WHITE
  t$ = "Use the PgUp, PgDn, Home, End, Esc, or Arrow keys"
  Future.PRINT bx + (w - LEN(t$)) * 4, by + 26 * 16 + 5, t$, RED, WHITE
  H = 0: h2 = -1: GOSUB Helpkey

  DO
    k = GETINKEY
    IF k > 0 THEN
      GOSUB Helpkey
    END IF
  LOOP UNTIL k = ESC

  '** Clear input buffers
  DO: Future.UpdateMouse: LOOP UNTIL Future.MouseB = 0
  DO: LOOP UNTIL INKEY$ = ""   '** Clear inkey buffer

  'Future.MouseOff
  Future.XMSput 0, 0, TempScreen
  DeallocateXMS TempScreen 'free up XMS memory
  Future.MouseOn

EXIT SUB

Helpkey:

  SELECT CASE k
  CASE HOME: H = 0
  CASE ENDKEY: H = nText - 25
  CASE PGDN: H = H + 25
  CASE PGUP: H = H - 25
  CASE UP: H = H - 1
  CASE DOWN: H = H + 1
  END SELECT

  H = MAX(MIN(H, nText - 25), 0)
  IF H <> h2 THEN
    h2 = H
    FOR I = 1 TO 25
      t$ = SPACE$(w)
      MID$(t$, 1) = a$(I + H)
      Future.PRINT bx, by + I * 16, t$, BLACK, WHITE
    NEXT I
  END IF

RETURN

END SUB

FUNCTION INBOX (X, Y, X1, Y1, x2, y2)
  IF X >= X1 AND Y >= Y1 THEN
    IF X <= x2 AND Y <= y2 THEN
      INBOX = TRUE
    ELSE
      INBOX = FALSE
    END IF
  ELSE
    INBOX = FALSE
  END IF
END FUNCTION

FUNCTION MAX (V1, V2)
  IF V1 > V2 THEN
    MAX = V1
  ELSE
    MAX = V2
  END IF
END FUNCTION

SUB MESSAGE (msg$, secs)
  SetViewPort 0, 0, 800, 600
  TempScreen = AllocateXMS(480000) 'get 256000 bytes of XMS memory
  Future.MouseOff
  Future.XMSget 0, 0, 800, 600, TempScreen

  bx = 300: by = 200
  FOR I = 1 TO LEN(msg$)
    IF MID$(msg$, I, 1) = "|" THEN k = k + 1
  NEXT I

  DIM txt$(k + 1)
  FOR I = 1 TO k
    P = INSTR(msg$, "|")
    txt$(I) = LEFT$(msg$, P - 1)
    msg$ = RIGHT$(msg$, LEN(msg$) - P)
  NEXT I
  txt$(k + 1) = msg$

  FOR I = 1 TO k + 1
    m = LEN(txt$(I))
    IF m > MaxL THEN MaxL = m
  NEXT I

  by2 = by + 50 + k * 16
  w = MaxL * 8 + 20
  Future.FILLBOX bx, by, bx + w, by2, RED
  Future.BOX bx - 1, by - 1, bx + w + 1, by2 + 1, BLACK
  Future.BOX bx - 2, by - 2, bx + w + 2, by2 + 2, BLACK


  FOR I = 1 TO k + 1
    Future.PRINT bx + 10, by + I * 16 - 6, txt$(I), WHITE, -1
  NEXT I
  Future.PRINT bx + (w - 60) / 2, by2 - 20, " ANYKEY ", RED, WHITE

  t1! = TIMER
  DO: LOOP UNTIL INKEY$ = ""
  DO: LOOP UNTIL Future.MouseB = 0
  DO
    IF LEN(INKEY$) THEN EXIT DO
    IF Future.MouseB THEN EXIT DO
  LOOP UNTIL TIMER - t1! > secs

  Future.MouseOff
  Future.XMSput 0, 0, TempScreen
  DeallocateXMS TempScreen 'free up XMS memory
  Future.MouseOn

END SUB

FUNCTION MIN (V1, V2)
  IF V1 < V2 THEN
    MIN = V1
  ELSE
    MIN = V2
  END IF

END FUNCTION

SUB ShiftStatus (status%)

  DEFINT A-Z
  DIM reg AS RegTypeX
  reg.ax = &H200
  InterruptX &H16, reg, reg
  status% = reg.ax
  EXIT SUB

  '!!!! Note must use AND to check for individual status!!!
  '** because typically caps lock or Num lock will also be on
  '** eg   IF status% AND 8 then alt button is down
  'shft right  = 1   scroll lock = 16
  'shft left   = 2   Num Lock    = 32
  'ctrl        = 4   Caps Lock   = 64
  'alt         = 8   Ins         =128

END SUB

