DECLARE SUB TerrainAssign (n%, n$, Foot%, Mech%, Mobile%, inf%, arm%, first%, damageMod%)
DECLARE SUB OrderAssign (n%, M1%, a1%, D1%, M2%, a2%, D2%, M3%, A3%, D3%, cmbt%)
DECLARE SUB UnitAssign (u%, s%, a%, d$, UT%, f%, MP%, eff%, hex%)
DECLARE SUB MESSAGE (msg$, secs%)
DECLARE SUB MoveDir (d%, X%, Y%, NX%, NY%)
DECLARE FUNCTION VictoryCheck% ()
DECLARE SUB GetPath (drive$, pp$)
DECLARE SUB MapDraw ()
DECLARE SUB UnitArrow (u%)
DECLARE SUB UnitDraw (u%)
DECLARE SUB anykey ()
DECLARE SUB Alert (Text$(), Buttons$(), X%, Y%, ReturnButton%)

DECLARE FUNCTION Player% (u%)
DECLARE FUNCTION GETINKEY% ()
DECLARE FUNCTION BIN$ (n%)
DECLARE FUNCTION MIN% (V1%, V2%)
DECLARE FUNCTION FORM$ (n!, d%)
DECLARE FUNCTION INBOX% (X%, Y%, X1%, Y1%, x2%, y2%)
DECLARE FUNCTION MAX% (V1%, V2%)
DECLARE FUNCTION EXIST% (file$)
DECLARE FUNCTION CalcDir% (C1%, r1%, C2%, r2%)
DECLARE FUNCTION ADJACENT% (col1%, row1%, col2%, row2%)
REM $INCLUDE: 'future.bi'
REM $DYNAMIC

DEFINT A-Z

  '********************* KeyBoard Constants ****************
  CONST left = 1075, RIGHT = 1077, PGDN = 1081, PGUP = 1073
  CONST UP = 1072, DOWN = 1080, ESC = 27, TABKEY = 9, CR = 13
  CONST HOME = 1071, ENDKEY = 1079, SHIFTTAB = 1015
  '****************  Color Constants ************************
  CONST BLACK = 0, WHITE = 4, RED = 3, DGREEN = 2, GREEN = 5, LTGREEN = 1
  CONST DBLUE = 6, BLUE = 7, LTBLUE = 8, LTGRAY = 9, GRAY = 10, DrGray = 11
  CONST YELLOW = 12, LtBrown = 13, Brown = 14
  '********************** Map Constants **************************
  '** Viewport size in pixels
  CONST px1 = 10, py1 = 100, px2 = 790, py2 = 570
  CONST bigstep = py2 - py1 - 10, smallstep = 50
  CONST SLIDERW = 8, nScreens = 4, xScreens = 2, yScreens = 2
  '************************ Logical Constants *******************
  CONST TRUE = -1, FALSE = 0
  CONST GERMAN = 0, RUSSIAN = 1

  COMMON SHARED workscreen, Buffer, Page
  COMMON SHARED mouseposY, mouseposX, LMousebutton, RMousebutton
  COMMON SHARED HexNumbers, CenterDots, HEXs, aHex, EZOC, MoveArea
  COMMON SHARED maxX, maxY, Ysize, Xsize, TotalX, TotalY
  COMMON SHARED cellsizeX, cellsizeY
  COMMON SHARED HX, HY, MSGSECS
  COMMON SHARED nUnits, TURN, Mode, Phase, cPLAYER, ActiveUnit
  COMMON SHARED map(), road(), river(), move(), zoc(), XMSscreens()
  COMMON SHARED tname() AS STRING * 10, Foot(), Mech(), Mobile(), inf(), arm(), first(), damMod()
  COMMON SHARED U1(), U2(), U3(), U4(), U5(), U6(), mask()
  COMMON SHARED r1(), r2(), r3(), r4(), r5(), r6(), r7(), r8()
  COMMON SHARED g1(), g2(), g3(), g4(), g5(), g6(), hex()
  COMMON SHARED a1(), a2(), a4(), a8(), a16(), a32()
  COMMON SHARED unittype(), army(), desgn$(), str(), ma(), UnitX(), UnitY()
  COMMON SHARED uOrder(), effectiveness(), skill(), mps()
  COMMON SHARED attack(), UT(), sHEX()
  COMMON SHARED army$(), aOrders(), ordertext() AS STRING * 10
  COMMON SHARED dir(), Mode$(), Phase$()
  COMMON SHARED orderEFF(), DamageEff()
  COMMON SHARED nSubm(), submenu()  AS STRING * 12

REM $STATIC
FUNCTION ADJACENT (col1, row1, col2, row2)

  ADJACENT = FALSE
  IF row1 - row2 = 0 THEN
    IF ABS(col1 - col2) = 1 THEN ADJACENT = TRUE
  ELSEIF ABS(row1 - row2) = 1 THEN
    test = col1 - col2 + row1 MOD 2
    IF test = 0 OR test = 1 THEN ADJACENT = TRUE
  ELSE
    ADJACENT = FALSE
  END IF


END FUNCTION

SUB ArmyOrders (side)
  DIM ly(nUnits), ulist(nUnits)
  SetViewPort 0, 0, 800, 600
  TempScreen = AllocateXMS(480000) 'get 256000 bytes of XMS memory
  Future.MouseOff
  Future.XMSget 0, 0, 800, 600, TempScreen

  bx = 50: by = 50: w = 500: H = 320
  IF side = RUSSIAN THEN
    Future.FILLBOX bx, by, bx + w, by + H, RED
    Future.PRINT bx + 200, by + 10, "Army Orders", BLACK, -1
    SA = 0
  ELSE
    Future.FILLBOX bx, by, bx + w, by + H, LTGRAY
    Future.PRINT bx + 200, by + 10, "Korp Orders", BLACK, -1
    SA = 9
  END IF

  '** Column Titles
  FOR I = 1 TO 4
    Tx = bx + 100 + 80 * I
    Future.PRINT Tx, by + 30, ordertext(I), BLACK, -1
  NEXT I

  '** Army Names, selection circles
  FOR a = 1 TO 6
    ly(a) = by + 40 * a + 20
    Future.PRINT bx + 20, ly(a), army$(a + SA), WHITE, -1
    FOR I = 1 TO 4
      Tx = bx + 140 + 80 * I
      Future.FILLCIRCLE Tx, ly(a) + 7, 7, WHITE
    NEXT I
    Future.FILLCIRCLE bx + 140 + 80 * aOrders(a + SA), ly(a) + 7, 3, BLACK
  NEXT a
  dx = bx + w / 2 - 24: dy = by + H - 24
  Future.PRINT dx, dy, " DONE ", RED, WHITE
  Future.MouseOn
  IF Phase = 1 THEN
    DONE = FALSE
  ELSE
    DIM t$(3), B$(1)
    t$(1) = "Orders may only be changed"
    t$(2) = "during the Orders Phase."
    t$(3) = ""
    B$(1) = "  OK  "
    CALL Alert(t$(), B$(), 0, 0, C)
    anykey
    GOTO DONE
  END IF

  DO
    Future.UpdateMouse
    IF Future.MouseB AND 1 THEN
      mx = Future.MouseX
      my = Future.MouseY
      IF INBOX(mx, my, dx, dy, dx + 48, dy + 16) THEN EXIT DO
      order = 0: army = 0
      FOR I = 1 TO 4
        Tx = bx + 140 + 80 * I
        IF ABS(mx - Tx) < 7 THEN order = I
      NEXT I
      FOR I = 1 TO 6
        IF ABS(my - ly(I) - 7) < 7 THEN army = I + SA
      NEXT I
      IF army > 0 AND order > 0 THEN
        Future.MouseOff
        IF aOrders(army) <> order THEN
          Future.FILLCIRCLE bx + 140 + 80 * aOrders(army), ly(army - SA) + 7, 7, WHITE
          aOrders(army) = order
          Future.FILLCIRCLE bx + 140 + 80 * aOrders(army), ly(army - SA) + 7, 3, BLACK
          Future.MouseOn
          FOR u = 1 TO nUnits
            IF army(u) = army THEN uOrder(u) = aOrders(army)
          NEXT u
        END IF
      END IF
      DO: Future.UpdateMouse: LOOP UNTIL Future.MouseB = 0
    END IF
  
    keyVaule = GETINKEY
    IF keyVaule = ESC OR keyVaule = CR THEN DONE = TRUE
    IF Future.MouseB AND 2 THEN DONE = TRUE

  LOOP UNTIL DONE

  FOR u = 1 TO nUnits
    IF Player(u) = cPLAYER THEN
      IF orderEFF(uOrder(u), UT(u), 1) = -1 THEN
        mps(u) = -1
      ELSE
        mps(u) = ma(u) * orderEFF(uOrder(u), UT(u), 1) / 100
      END IF
    END IF
  NEXT u

DONE:

  DO: LOOP UNTIL INKEY$ = ""   '** Clear inkey buffer
  Future.MouseOff
  Future.XMSput 0, 0, TempScreen
  DeallocateXMS TempScreen 'free up XMS memory
  Future.MouseOn
  MapDraw



END SUB

SUB arrow (X1, Y1, d)
  SELECT CASE d
  CASE 0
  CASE 1
    Future.PUT X1, Y1, a1()
  CASE 2
    Future.PUT X1, Y1, a2()
    UnitText& = WHITE
  CASE 3
    Future.PUT X1, Y1, a4()
  CASE 4
    Future.PUT X1, Y1, a8()
  CASE 5
    Future.PUT X1, Y1, a16()
  CASE 6
    Future.PUT X1, Y1, a32()
  CASE ELSE
  END SELECT

END SUB

FUNCTION CalcDir (C1, r1, C2, r2)
  IF r1 = r2 THEN
    IF C2 > C1 THEN
      CalcDir = 1
    ELSE
      CalcDir = 8
    END IF
  ELSEIF r2 > r1 THEN
    IF C2 - C1 - (r1 MOD 2) THEN
      CalcDir = 16
    ELSE
      CalcDir = 32
    END IF
  ELSE
    IF C2 - C1 - (r1 MOD 2) THEN
      CalcDir = 4
    ELSE
      CalcDir = 2
    END IF
  END IF
END FUNCTION

SUB Credits

  DIM t$(12), B$(1)

  t$(1) = "          Wargame  "
  t$(2) = "   Version 1.0 9/4/2000 "
  t$(3) = "Created by Thomas A Stevenson "
  t$(4) = "  thomas99@phenixcable.net"
  t$(5) = ""
  t$(6) = "    Written in QBasic 4.5 "
  t$(7) = "  Using Future.Library 3.03"
  t$(8) = "   By Michael Rye Soreason "
  t$(9) = "     and Jorden Chamid     "
  t$(10) = "   Source code available"
  t$(11) = "       upon request."
  t$(12) = ""

  B$(1) = "  OK  "

  CALL Alert(t$(), B$(), 0, 0, C)



END SUB

SUB HelpOrders
  SetViewPort 0, 0, 800, 600
  TempScreen = AllocateXMS(480000) 'get 256000 bytes of XMS memory
  Future.MouseOff
  Future.XMSget 0, 0, 800, 600, TempScreen

  P$ = "Blitzwar.pal"
  SavePal (P$)
  t$ = "ordtable.gif"
  IF EXIST(t$) THEN
    SetViewPort 163, 126, 687, 430
    WAIT &H3DA, 8 'VSYNC
    Future.LoadGIF t$, 800, 600
    SetViewPort 0, 0, 800, 600
  ELSE
    Future.CLS 0
    Future.PRINT 30, 30, "File not Found " + t$, RED, WHITE
  END IF

  Future.MouseOn
  CALL anykey

  Future.MouseOff
  LoadPal (P$)
  Future.XMSput 0, 0, TempScreen
  DeallocateXMS TempScreen 'free up XMS memory
  Future.MouseOn

END SUB

SUB HelpTerrain
  SetViewPort 0, 0, 800, 600
  TempScreen = AllocateXMS(480000) 'get 256000 bytes of XMS memory
  Future.MouseOff
  Future.XMSget 0, 0, 800, 600, TempScreen

  t$ = "Teffects.gif"
  IF EXIST(t$) THEN
    SetViewPort 228, 131, 649, 459
    WAIT &H3DA, 8 'VSYNC
    Future.LoadGIF t$, 800, 600
    SetViewPort 0, 0, 800, 600
  ELSE
    Future.CLS 0
    Future.PRINT 30, 30, "File not Found " + t$, RED, WHITE
  END IF

  Future.MouseOn
  CALL anykey

  Future.MouseOff
  Future.XMSput 0, 0, TempScreen
  DeallocateXMS TempScreen 'free up XMS memory
  Future.MouseOn
END SUB

SUB MapDraw

  Future.MouseOff  '** Hide mouse while we draw to screen
  Future.XMSget 0, 0, 800, 600, workscreen
  Page = Page XOR 1
  SetPage Page
  Future.XMSput 0, 0, workscreen

  Sy = HY \ cellsizeY
  Sx = HX \ cellsizeX
  Y1 = MAX(Sy - 1, 0): y2 = MIN(Sy + Ysize, TotalY - 1)
  X1 = MAX(Sx - 1, 0): x2 = MIN(Sx + Xsize, TotalX - 1)

  SetViewPort px1, py1, px2, py2
  Future.CLS 0
  FOR I = 1 TO nScreens
    lx = px1 + XMSscreens(I, 1) - HX
    ly = py1 + XMSscreens(I, 2) - HY
    IF ABS(lx) <= 800 AND ABS(ly) <= 600 THEN
      Future.XMSput lx, ly, XMSscreens(I, 0)
    END IF
  NEXT I
  IF MoveArea OR EZOC THEN GOSUB MOVEZONE
  IF CenterDots THEN GOSUB CDots
  IF HexNumbers THEN GOSUB dNUMs
  IF HEXs THEN GOSUB dHEXs
  FOR u = 1 TO nUnits
    UnitDraw u
  NEXT u
  FOR u = 1 TO nUnits
    IF attack(u) > 0 THEN UnitArrow (u)
  NEXT u

  '******** Draw Sliders ****************************
  SetViewPort 0, 0, 800, 600
  Future.FILLBOX px2, py1, px2 + SLIDERW, py2, WHITE
  ww! = (py2 - py1) / (cellsizeY * TotalY) * (py2 - py1)
  VPOS = py1 + ((py2 - py1 - ww!) / maxY) * HY
  Future.FILLBOX px2, VPOS, px2 + SLIDERW, VPOS + ww!, RED

  Future.FILLBOX px1, py2, px2, py2 + SLIDERW, WHITE
  ww! = (px2 - px1) / (cellsizeX * TotalX) * (px2 - px1)
  HPOS = px1 + ((px2 - px1 - ww!) / maxX) * HX
  Future.FILLBOX HPOS, py2, HPOS + ww!, py2 + SLIDERW, RED

  Future.LINE px1, py1 - 1, px2 + SLIDERW, py1 - 1, WHITE, -1
  Future.LINE px1 - 1, py1 - 1, px1 - 1, py2 + SLIDERW, WHITE, -1

  '****  Update Turn Status
  IX = 480
  P$ = "GERMAN ": IF cPLAYER <> GERMAN THEN P$ = "RUSSIAN"
  Future.PRINT IX, 0, P$ + " Player", RED, WHITE
  Future.PRINT IX + 14 * 8, 0, " Turn" + STR$(TURN) + " ", RED, WHITE
  Future.PRINT IX + 22 * 8, 0, Phase$(Phase), WHITE, RED
  Future.PRINT IX, 16, "Action: " + Mode$(Mode), RED, WHITE

  '**** Draw Menubar
  FOR m = 1 TO nSubm(0)
     Future.PRINT 80 * (m - 1), 0, submenu(m, 0), BLACK, BLUE
  NEXT m

  Future.MouseOn
  ViewPage Page

EXIT SUB

MOVEZONE:
  '*** Area of possible movement for current unit and EZOC
  FOR my = Y1 TO y2
    Ty = my * cellsizeY + cellsizeY / 2 - 1 - HY + py1
    Xoff = px1 - HX + (my MOD 2) * cellsizeX / 2 - 1
    FOR mx = X1 TO x2
      Tx = mx * cellsizeX + Xoff
      IF MoveArea = FALSE THEN
        IF zoc(mx, my) THEN Future.PRINT Tx - 10, Ty - 8, "ZOC", RED, -1
      ELSEIF move(mx, my) > -1 THEN
        SetMaskColor 0
        Future.PUT Tx - cellsizeX / 2 - 1, Ty - 5 - cellsizeY / 2, hex()
        SetMaskColor -1
        s$ = LTRIM$(STR$(INT(move(mx, my) / 2)))
        Future.PRINT Tx - LEN(s$) * 4, Ty - 8, s$, RED, -1
      ELSEIF zoc(mx, my) THEN
        IF EZOC THEN Future.PRINT Tx - 10, Ty - 8, "ZOC", RED, -1
      END IF
    NEXT mx
  NEXT my
RETURN

dNUMs:
  '**** Draw Hex numbering system
  s$ = "0000"
  FOR my = Y1 TO y2
    Ty = my * cellsizeY + cellsizeY / 2 - 1 - HY + py1
    Xoff = px1 - HX + (my MOD 2) * cellsizeX / 2 - 1
    FOR mx = X1 TO x2
      t$ = s$ + LTRIM$(STR$(my * 100 + mx))
      t$ = MID$(t$, LEN(t$) - 3, 4)
      Tx = mx * cellsizeX + Xoff
      Future.PRINT Tx - 16, Ty - 7, t$, RED, -1
    NEXT mx
  NEXT my
RETURN

CDots:
  '**** Draw Center dots
  FOR my = Y1 TO y2
    Ty = my * cellsizeY + cellsizeY / 2 - 1 - HY + py1
    Xoff = px1 - HX + (my MOD 2) * cellsizeX / 2 - 1
    FOR mx = X1 TO x2
      Tx = mx * cellsizeX + Xoff
      Future.FILLBOX Tx, Ty, Tx + 1, Ty + 1, WHITE
    NEXT mx
  NEXT my
RETURN

dHEXs:
  '***** Draw Hex sides
  m = 6
  FOR my = Y1 TO y2
    ty1 = my * cellsizeY - HY + py1
    ty2 = ty1 + cellsizeY
    Xoff = px1 - HX + ((my + 1) MOD 2) * cellsizeX / 2
    FOR mx = X1 - 1 TO x2
      tx1 = mx * cellsizeX + Xoff
      tx2 = tx1 + cellsizeX
      tX12 = tx1 + cellsizeX / 2
      Future.LINE tx1, ty1 + m, tX12, ty1 - m, WHITE, -1
      Future.LINE tX12, ty1 - m, tx2, ty1 + m, WHITE, -1
      Future.LINE tx2, ty1 + m, tx2, ty2 - m, WHITE, -1
    NEXT mx
  NEXT my
RETURN

END SUB

SUB MapLoad (m$)

  drive$ = "C"
  CALL GetPath(drive$, pp$)
  file$ = m$ + ".bin"

  IF EXIST%(file$) THEN
    f = FREEFILE
    OPEN file$ FOR RANDOM AS f
    Bytes = LOF(f)
    CLOSE f
    TotalWords = (Bytes - 7) / 2
    DIM DAT(1 TO TotalWords)

    DEF SEG = VARSEG(DAT(1))
    BLOAD file$, VARPTR(DAT(1))
    DEF SEG
  ELSE
    DIM t$(4), B$(1)
    t$(1) = "Map Data File Not Found"
    t$(2) = drive$ + ":\" + pp$ + "\" + file$
    t$(3) = "Starting with blank Map"
    B$(1) = "  OK  "
    CALL Alert(t$(), B$(), 0, 0, C)
    GOTO loadScreens
  END IF

  TotalX = DAT(1)
  TotalY = DAT(2)
  cellsizeX = DAT(3)
  cellsizeY = DAT(4)

  maxX = cellsizeX * TotalX - (px2 - px1)
  maxY = cellsizeY * TotalY - (py2 - py1)
  Ysize = (py2 - py1) / cellsizeY + 1
  Xsize = (px2 - px1) / cellsizeX + 1

  REDIM map(TotalX - 1, TotalY - 1)
  REDIM road(TotalX - 1, TotalY - 1)
  REDIM river(TotalX - 1, TotalY - 1)
  REDIM move(TotalX - 1, TotalY - 1)
  REDIM zoc(TotalX - 1, TotalY - 1)

  FOR Y = 0 TO TotalY - 1
    FOR X = 0 TO TotalX - 1
      move(X, Y) = -1
    NEXT X
  NEXT Y

  I = 20
  FOR Y = 0 TO TotalY - 1
    FOR X = 0 TO TotalX - 1
      I = I + 1: map(X, Y) = DAT(I)
      I = I + 1: road(X, Y) = DAT(I)
      I = I + 1: river(X, Y) = DAT(I)
    NEXT X
  NEXT Y

loadScreens:

  Future.PRINT 300, 220, "Loading maps", BLACK, WHITE
  Page = Page XOR 1
  SetPage Page

  base$ = "scr": ext1$ = ".gif": ext2$ = ".BMP"
  FOR n = 1 TO nScreens
    t$ = base$ + RIGHT$("0" + LTRIM$(STR$(n)), 2) + ext1$
    IF EXIST(t$) THEN
      Future.LoadGIF t$, 800, 600
    ELSE
      t$ = base$ + RIGHT$("0" + LTRIM$(STR$(n)), 2) + ext2$
      Future.CLS GREEN
      IF EXIST(t$) THEN
        Future.LoadBMP t$, 0, 0
      ELSE
        ViewPage Page
        Future.PRINT 0, 0, "file not Found" + t$, WHITE, BLACK
        BEEP
      END IF
    END IF
    Future.XMSget 0, 0, 800, 600, XMSscreens(n, 0)
  NEXT n
  Page = Page XOR 1
  SetPage Page

EXIT SUB


END SUB

SUB MoveDir (d, X, Y, NX, NY)

  SELECT CASE d
  CASE 1
    NX = X + 1
    NY = Y
  CASE 2
    NX = X + ABS(Y MOD 2)
    NY = Y - 1
  CASE 4
    NY = Y - 1
    NX = X - ABS(NY MOD 2)
  CASE 8
    NX = X - 1
    NY = Y
  CASE 16
    NY = Y + 1
    NX = X - ABS(NY MOD 2)
  CASE 32
    NX = X + ABS(Y MOD 2)
    NY = Y + 1
  CASE ELSE
  END SELECT

END SUB

SUB MSGLENGTH

  DIM t$(3), B$(4)

  t$(1) = "  Select how many seconds to leave "
  t$(2) = "  messages on screen. "

  B$(1) = " 0 "
  B$(2) = " 1 "
  B$(3) = " 3 "
  B$(4) = " 5 "

  CALL Alert(t$(), B$(), 0, 0, C)
  MSGSECS = VAL(B$(C))

END SUB

SUB Reinforcements

  IF cPLAYER = GERMAN THEN EXIT SUB

  DIM rh(TotalX, TotalY)
  FOR I = 1 TO nUnits
    IF unittype(I) = 0 THEN
      '** unit not in play
    ELSEIF Player(I) = GERMAN THEN
      rh(UnitX(I), UnitY(I)) = -1
      FOR k = 1 TO 6
        MoveDir dir(k), UnitX(I), UnitY(I), dx, dy
        IF INBOX(dx, dy, 0, 0, TotalX - 1, TotalY - 1) THEN rh(dx, dy) = TRUE
      NEXT k
    ELSE
      rh(UnitX(I), UnitY(I)) = -2
    END IF
  NEXT I

  SELECT CASE TURN
  CASE 2
    MESSAGE "Russian 77th Army |has arrived", 5
    army$(7) = "77th Army": aOrders(7) = 3
    UnitAssign 21, 5, 7, "444th INF", 2, 5, 5, 6, 1131
    UnitAssign 22, 5, 7, "323rd INF", 2, 5, 5, 6, 1231
    UnitAssign 23, 5, 7, "255th INF", 2, 5, 5, 6, 1431
    u = 21: GOSUB checkhex
    u = 22: GOSUB checkhex
    u = 23: GOSUB checkhex
  CASE 5
    MESSAGE "Russian 4th Tank Army |has arrived", 5
    army$(8) = "4th Tank": aOrders(8) = 3
    UnitAssign 24, 4, 8, "5th Tank", 2, 10, 7, 7, 1931
    UnitAssign 25, 4, 8, "8th Tank", 2, 12, 7, 7, 2031
    UnitAssign 26, 6, 8, "1st Mech", 2, 8, 6, 7, 2131
    u = 24: GOSUB checkhex
    u = 25: GOSUB checkhex
    u = 26: GOSUB checkhex
  END SELECT

EXIT SUB
  


checkhex:

  IF rh(UnitX(u), UnitY(u)) = -2 THEN
    unittype(u) = 0
    m$ = "Hex" + STR$(UnitX(u) + 100 * UnitY(u)) + " already occupied"
    m$ = m$ + desgn$(u) + " may not enter!"
    MESSAGE m$, 3
  ELSEIF rh(UnitX(u), UnitY(u)) = -1 THEN
    unittype(u) = 0
    m$ = "Hex" + STR$(UnitX(u) + 100 * UnitY(u)) + " under German Control|"
    m$ = m$ + desgn$(u) + " may not enter!"
    MESSAGE m$, 3
  END IF

RETURN

END SUB

SUB setup
  workscreen = AllocateXMS(480000)
  Buffer = AllocateXMS(480000)
  FOR I = 1 TO nScreens
    XMSscreens(I, 0) = AllocateXMS(480000)
  NEXT I
  FOR I = 1 TO xScreens
    FOR j = 1 TO yScreens
      k = j + (I - 1) * xScreens
      XMSscreens(k, 1) = 800 * (I - 1)
      XMSscreens(k, 2) = 600 * (j - 1)
    NEXT j
  NEXT I

  Set800x600 8   'Set  svga screen
  SLEEP 1
  ChangePal WHITE, 255, 255, 255
  ChangePal RED, 255, 0, 0
  ChangePal DBLUE, 0, 10, 128
  ChangePal BLUE, 0, 0, 255
  ChangePal LTBLUE, 0, 255, 255
  ChangePal DGREEN, 0, 25, 0
  ChangePal GREEN, 0, 128, 0
  ChangePal LTGREEN, 0, 255, 0
  ChangePal DrGray, 150, 150, 150
  ChangePal GRAY, 128, 128, 128
  ChangePal YELLOW, 255, 255, 0
  ChangePal LTGRAY, 150, 150, 150


  Future.CLS 0
  Future.PRINT 300, 200, "Calling setup", BLACK, WHITE
  Page = Page XOR 1
  SetPage Page
  Future.CLS 0
  u$ = "Units.bmp"
  IF EXIST(u$) THEN Future.LoadBMP u$, 0, 0
  Future.GET 0, 0, 40, 40, U1()
  Future.GET 41, 0, 80, 40, U2()
  Future.GET 81, 0, 120, 40, U3()
  Future.GET 0, 41, 40, 80, U4()
  Future.GET 41, 41, 80, 80, U5()
  Future.GET 81, 41, 120, 80, U6()

  Future.GET 1, 81, 17, 89, r1()
  Future.GET 19, 81, 35, 89, r2()
  Future.GET 37, 81, 53, 89, r3()
  Future.GET 55, 81, 71, 89, r4()
  Future.GET 73, 81, 89, 89, r5()
  Future.GET 91, 81, 107, 89, r6()
  Future.GET 109, 81, 125, 89, r7()
  Future.GET 127, 81, 140, 89, r8()

  Future.GET 1, 93, 17, 100, g1()
  Future.GET 19, 93, 35, 100, g2()
  Future.GET 37, 93, 53, 100, g3()
  Future.GET 55, 93, 71, 100, g4()
  Future.GET 73, 93, 89, 100, g5()
  Future.GET 91, 93, 107, 100, g6()
  Future.GET 122, 0, 174, 62, hex()
  Future.PUT 300, 0, hex()

  w = 20
  Future.GET 141, 71, 141 + w, 91, a1()
  Future.GET 163, 71, 163 + w, 91, a2()
  Future.GET 185, 71, 185 + w, 91, a4()
  Future.GET 207, 71, 207 + w, 91, a8()
  Future.GET 229, 71, 229 + w, 91, a16()
  Future.GET 251, 71, 251 + w, 91, a32()

  X1 = 200: Y1 = 200
  FOR Y = Y1 TO Y1 + 40 STEP 3
    FOR X = X1 TO X1 + 40 STEP 2
      Future.PSET X + Y MOD 2, Y, WHITE
    NEXT X
  NEXT Y
  Future.GET X1, Y1, X1 + 40, Y1 + 40, mask()

  Page = Page XOR 1
  SetPage Page

  desgn$(0) = SPACE$(14)
  army$(0) = SPACE$(20)
  uOrder(0) = 0

  TerrainAssign 1, "Clear", 1, 1, 1, 100, 150, 1, 125
  TerrainAssign 2, "Woods", 2, 4, 2, 150, 75, 0, 100
  TerrainAssign 3, "Fortified", 2, 4, 2, 300, 200, 1, 50
  TerrainAssign 6, "Rough", 3, 5, 3, 200, 150, 1, 85
  TerrainAssign 7, "Ocean", 100, 100, 100, 1, 1, 0, 300
  TerrainAssign 8, "Maj River", 4, 6, 4, 75, 75, 0, 150
  TerrainAssign 9, "City", 1, 2, 1, 300, 75, 0, 75

  dir(1) = 1: dir(2) = 2: dir(3) = 4: dir(4) = 8: dir(5) = 16: dir(6) = 32
  MSGSECS = 1

  Mode$(0) = "Right Click to check/chg Orders"
  Mode$(1) = "Select Friendly Unit           "
  Mode$(2) = "Select Hex to Move to or Attack"
  Mode$(3) = "Select Units to add to Attack  "
  Mode$(4) = "Select Hex to retreat to       "
  Phase$(1) = "  Orders Phase   "
  Phase$(2) = "  Action Phase   "
  Phase$(3) = "  Recovery Phase "

  ordertext(0) = SPACE$(9)
  ordertext(1) = "Must Hold"
  ordertext(2) = "Defend"
  ordertext(3) = "Mobile"
  ordertext(4) = "Assault"
  OrderAssign 1, 0, 0, 200, 0, 0, 200, -1, 50, 200, 75
  OrderAssign 2, 0, 50, 150, -1, 100, 150, 50, 100, 150, 85
  OrderAssign 3, 100, 200, 100, 100, 100, 100, 200, 100, 120, 125
  OrderAssign 4, -1, 200, 100, -1, 150, 100, 100, 150, 100, 100

END SUB

SUB UnitDrag (u, FX, FY)
 
  '** This subroutine is not used

  'DIM SHARED M1(s), M2(s), mask(s)
  '* X,Y = screen coordinates of unit to drag
  'Y = UnitY(u) * cellsizeY - HY + py1
  'X = UnitX(u) * cellsizeX + px1 - HX - ((UnitY(u) + 1) MOD 2) * cellsizeX / 2

  Future.MouseOff
  'Future.GET aHex + X - 1, aHex + Y - 1, aHex + X + 38, aHex + Y + 38, M1()
  SetMaskColor 0
  'Future.PUT aHex + X - 1, aHex + Y - 1, mask()
  SetMaskColor -1
  kx = mouseposX: ky = mouseposY
  'Future.GET kx, ky, kx + 40, ky + 40, M2()
  Future.XMSget 0, 0, 800, 600, workscreen
  Page = Page XOR 1
  SetPage Page
  Future.XMSput 0, 0, workscreen
  ViewPage Page
  SetViewPort px1, py1, px2, py2
  DO
    Future.UpdateMouse
    mouseposX = Future.MouseX
    mouseposY = Future.MouseY
    '** Copy front screen  to back screen
      Future.XMSget px1, py1, px2, py2, workscreen
      Page = Page XOR 1
      SetPage Page
      Future.XMSput px1, py1, workscreen
    '** erase sprite by terrain over it
      'Future.PUT kx, ky, M2()
      kx = mouseposX: ky = mouseposY
    '** copy terrain for later use
    'Future.GET kx, ky, kx + 40, ky + 40, M2()
    '** put unit icon back on map
    'Future.PUT kx, ky, M1()
    kx = mouseposX: ky = mouseposY
    ViewPage Page
  LOOP UNTIL Future.MouseB = 0
  SetViewPort 0, 0, 800, 600
  Future.MouseOn

END SUB

FUNCTION VictoryCheck%

  DIM V(TotalX, TotalY)
  FOR I = 1 TO nUnits
    IF unittype(I) = 0 THEN
      '** unit not in play
    ELSEIF Player(I) = GERMAN THEN
      V(UnitX(I), UnitY(I)) = -1
      FOR k = 1 TO 6
        MoveDir dir(k), UnitX(I), UnitY(I), dx, dy
        IF INBOX(dx, dy, 0, 0, TotalX - 1, TotalY - 1) THEN V(dx, dy) = TRUE
      NEXT k
    END IF
  NEXT I

  DIM t$(8), B$(1)
  t$(1) = "       Victory Check      "
  t$(2) = "   "
  t$(3) = "Hex 1526 is not in a German ZOC"
  IF V(26, 15) THEN t$(3) = "Hex 1526 is in a German ZOC"
  t$(4) = "Hex 1427 is not in a German ZOC"
  IF V(27, 14) THEN t$(4) = "Hex 1427 is in a German ZOC"
  t$(5) = "Hex 1527 is not in a German ZOC"
  IF V(27, 15) THEN t$(5) = "Hex 1527 is in a German ZOC"
  t$(7) = "German Player has not won"
  IF V(27, 15) AND V(26, 15) AND V(27, 14) THEN
    t$(7) = "German Player has won"
    VictoryCheck% = TRUE
  ELSE
    VictoryCheck% = FALSE
  END IF
  B$(1) = "  OK  "
  CALL Alert(t$(), B$(), 0, 0, C)

END FUNCTION

